{--------------------------------------------------------}
{
{    Interpretador de script
{
{    Autor: Jos Antonio Borges
{
{    Em 23/06/2000
{
{--------------------------------------------------------}

{------------------------------------------------------------------------------------------}
{
{    Resumo da sintaxe
{
{    Interaes com o usurio
{        escreve [MUDO] ["frase" ou variavel]...  {terminado por & nao pula linha
{        fala ["frase" ou variavel]
{        le [MUDO ou SENHA] [variavel]            {terminado por & l s uma tecla
{        tela [limpa ou minimizada ou normal ou @x,y]
{        bipa [tipoBip]                           { 0 = bip  1 = clek
{        cor ["valor" ou variavel]
{        fundo ["valor" ou variavel]
{        observa TECLADO [variavel]    {0: no foi teclado nada   1: requer leitura
{
{    Menu interativo
{        menu CRIA xmin ymin xmax ymax
{        menu ADICIONA ["valor" ou variavel]
{        menu EXECUTA [variavel] [variavel] [variavel]    { retornados:
{                                        nmero do item, letra teclada e item }
{        menu TERMINA
{
{    Operaes com arquivo
{        abre #n arquivo     {terminado por & arquivo e' criado ou acrescentado se existir
{        fecha #n
{        le #n variavel
{        escreve #n [variavel]                 {terminado por & nao pula linha
{        remove ["nomeArquivo" ou variavel]    {terminado por & no d erro se no apagar
{        renomeia ["nomeArquivo" ou variavel] ["novoNome" ou variavel]
{                                              {terminado por & no d erro se no renomear
{        replica ["nomeArquivo" ou variavel] ["novoNome" ou variavel]
{                                              {terminado por & no d erro se no renomear
{        busca [variavel] [DIR] [["nomeArqs" ou varivel] ou PRXIMO]
{                            { se omitido nome ou PRXIMO devolve diretrio atual
{        dir [CRIA, REMOVE, TROCA] ["nomeDiretorio" ou variavel]
{                                  {terminado por & no d erro
{        checa [variavel]          {resultado da ltima operacao le, escreve
{                                  {0: No houve problemas    > 0: erro
{
{    Operaes com Internet
{        internet [INICIA, TERMINA]
{        conecta #n ["valor" ou variavel] ["porta" ou variavel]
{        serve #n ["porta" ou variavel]
{        observa #n [variavel]    {0: porta no requer ateno   1: requer leitura
{        ip [LOCAL, REMOTO] #n [variavel]
{
{    Processamento de desvios
{        executa ["programa" ou variavel]     {terminado por & nao espera terminar
{        desvia [SCRIPT] [@rotulo ou variavel]
{        chama [@rotulo ou variavel]
{        retorna
{        se [NO] [variavel] [comparador] ["valor" ou variavel] comando
{        cmd [variavel]
{        termina [mudo]
{        debug [-]
{
{    Processamentos de comandos mltiplos e repeties
{        se [NO] [variavel] [comparador] ["valor" ou variavel]
{               seno     opcional
{               fim se        marca o final
{        enquanto [NO] [variavel] [comparador] ["valor" ou variavel]
{               fim enquanto        marca o final
{        repete [variavel] ["valor" ou variavel]
{               fim repete          marca o final
{
{    Processamento de variveis
{        seja [variavel] [ = ] [expresso]
{        ou
{        seja [variavel] [ = ] [funcaoOpcional] [valor ou variavel]...
{                * aps as funes DATA, HORA e DIA no se coloca [valor ou variavel]
{                 opcional usar um sinal de = aps a varivel
{        soma [variavelDest] [valor ou variavel]
{                na soma, eventuais prefixos alfabticos da varivel so mantidos
{        subtrai [variavelDest] [valor ou variavel]
{        multiplica [variavelDest] [valor ou variavel]
{        divide [variavelDest] [valor ou variavel]
{        concatena [variavelDest] [valor ou variavel]
{        copia [variavelDest] [variavel] [caracinicio] [caracfim]
{        transfere [DE, PARA] [variavel]
{        substitui [variavel] [valor antigo] [valor novo]
{        randomiza
{
{    Operaes com janelas
{        espera [tempoEmSegundos]
{        espera [tempo] ["nome janela" ou variavel]
{        janela [FECHA, MINIMIZA, MAXIMIZA, NORMAL] ["nome janela" ou variavel]
{        captura [TTULO ou ATIVA, CAMPO, FOCO] [variavel]
{
{    Aes do teclado e mouse
{        digita "frase" [enter]
{        aciona [tecla virtual]
{        clica [DUPLO, NULO] [onde]
{        le [MOUSE ou RATO] [onde]
{
{    Aes de multimdia
{        toca "frase" ou varivel                 {terminado por & nao espera terminar
{        mci [variavelRetorno] ["frase" ou varivel]
{        imagem "arquivo" x y                     {terminado por & ignora erro
{        sensor [variavel]      {informa o sensor ativo (1..32) da matriz Mapavox}
{
{    Processamento MSAA
{        MSAA captura x y
{        MSAA monitora
{        MSAA fim
{        MSAA checa
{        MSAA nome [variavel]
{        MSAA codigo [variavel]
{        MSAA tipo [variavel]
{        MSAA estado [variavel]
{        MSAA valor [variavel]
{        MSAA area  [variavel x] [variavel y] [variavel larg] [variavel alt]
{
{    Aes de mostrar imagem
{        IMAGEM ""
{        IMAGEM "arq_bmp_ou_jpg" x y   -> se x y omitido, vale (1,1)
{                                      -> se terminado por & ignora erro de arquivo
{
{------------------------------------------------------------------------------------------}
{
{    [valor]     "cadeia de caracteres" ou nmero ou (expresso) ou posio de vetor
{    [expresso] expresso inteira com os operadores (+-*/) e parnteses
{    [funcaoOpcional]    TAMANHO, MAIUSC, RAND, TRIM, POS [variavel ou valor],
{                        DATA, DIA, HORA, TEMPO, PALAVRA
{    [variavel]  letra de a-z (maiusculas = minusculas)
{                ou $ seguido por vrias letras de a-z ou 0-9
{                ou posio de vetor
{    [comparador] '=' '<>' '<' '>' '>=' '<='
{                 '==' '*=*' '=*' '*='
{    [rotulo]  qualquer coisa comeada por '@'
{    [arquivo]  frase ou variavel
{    comentario: linha comeada por *
{    [Onde]
{        x, y
{        tela x, y
{
{------------------------------------------------------------------------------------------}

unit dvscript;

interface
uses dvwin, dvcrt, windows, classes,
messages, sysUtils, mmsystem,midi, lista,
{$IFDEF VER150}
dateutils,
{$ENDIF}
dvmacro, dvexec, winsock, dvinet, dvmsaa, dvform, dvjpeg, dvhora;

const
SCR_OK = 0;
SCR_ERROEXEC = 1;
SCR_SEMARQUIVO = 2;
SCR_ROTULOINVALIDO = 3;
var
varScript: array ['A'..chr(ord('Z') + 101)] of string;
nomeVarLonga: TStringList;
fimScript, fimScriptMudo: boolean;

function cmdScript (lido: string): boolean;
function executaScript (nomeArq, rotulo: string; var ultLinhaProc: integer): integer;
procedure zeraVarScript;
function obtemVarLongaScript (nome: string): string;
procedure alteraVarLongaScript (nome, valor: string);
function processaCHR(recebido:string):string;
function getflags():string;

implementation

const
MAXSCRIPT = 5000;
MAXRETORNO = 20;

const
DEBUG_DESLIGADO  = 'Debug desligado';
DEBUG_LIGADO     = 'Debug ligado';
ERRO_ABRE        = 'Erro na abertura do arquivo';
ERRO_FECHA       = 'Erro no fechamento do arquivo';
ERRO_ARQUIVO     = 'Erro no processamento de arquivo';
ERRO_ESCRITA     = 'Erro na escrita de arquivo';
ERRO_APAGA       = 'Erro no apagamento do arquivo ';
ERRO_DIR         = 'Erro no processamento do diretrio ';
ERRO_CONEXAO     = 'Erro de conexao';
ERRO_PORTA       = 'Erro na porta TCP/IP';
DIVISAO_ZERO     = 'Diviso por zero';
LISTA_JA_EXISTE = 'A lista especificada j existe';
MUITAS_LISTAS = 'Muitas listas no programa (mximo 20)';
STACK_OVERFLOW   = 'Muitas chamadas sem retorno';
STACK_UNDERFLOW  = 'Retorno sem chamada';
COMANDO_INVALIDO = 'Comando invlido: ';

type
vetScript = array [1..MAXSCRIPT] of string;

TARQ = record
aberto: boolean;
internet: boolean;
soquete: longint;
pbuf: pBufRede;
arq: text;
end;

var
MIDIaberto:boolean;
script: vetScript;
nlinhasScript: integer;
linhaAtual: integer;
topoRetorno: integer;
pilhaRetorno: array [1..MAXRETORNO] of integer;
debug: boolean;
erroProc: boolean;
cmd: string;
varLista: array [0..20] of pListaRec;
arq: text;
statusUltIO: integer;
itemInic: integer;

tempo0: longint;
semana0: word;

arquivo: array ['0'..'9'] of TARQ;

dirInfo: TSearchRec;
atribBusca: word;
sensorAtivo: boolean;


function calculaExpressao (var s: string; var v: integer): boolean; forward;

var
line: string;
pl, lastpl: integer;

{--------------------------------------------------------}
{             carrega um script na memoria
{--------------------------------------------------------}

function carregaScript (nomeArq: string): boolean;
var
lido: string;
begin
assign (arq, nomeArq);
{$I-} reset (arq);  {$I+}
if ioresult <> 0 then
begin
carregaScript := false;
exit;
end;

nlinhasScript := 0;
while (not eof (arq)) do
begin
readln (arq, lido);
nlinhasScript := nlinhasScript + 1;
script[nlinhasScript] := trim (lido);
end;

close (arq);
carregaScript := true;
end;

{--------------------------------------------------------}
{                 libera a area de script
{--------------------------------------------------------}

procedure liberaScript;
begin
nlinhasScript := 0;
end;

{--------------------------------------------------------}
{             busca um rtulo no arquivo
{--------------------------------------------------------}

function buscaRotulo (rotulo: string): boolean;
var i: integer;
lido: string;
begin
rotulo := maiuscAnsi (rotulo);
for i := 1 to nlinhasScript do
begin
lido := script[i];
if (lido <> '') and (lido[1] = '@') then
begin
if maiuscAnsi (copy (lido, 2, length (lido)-1)) = rotulo then
begin
buscaRotulo := true;
linhaAtual := i;
exit;
end;
end;
end;
buscaRotulo := false;
end;

{--------------------------------------------------------}
{              extrai uma variavel longa do comando
{--------------------------------------------------------}

function extraiVariavelLonga (var lido: string; var v: char): boolean;
var nome: string;
n: integer;
begin
extraiVariavelLonga := false;
delete (lido, 1, 1);
if lido = '' then
begin exit end;

while (lido <> '') and (upcase(lido[1]) in ['A'..'Z', '0'..'9', '_']) do
begin
nome := nome + upcase(lido[1]);
delete (lido, 1, 1);
end;

if length (nome) = 0 then
begin exit end;

n := nomeVarLonga.indexOf(nome);
if n < 0 then
begin
nomeVarLonga.Add(nome);
n := nomeVarLonga.count-1;
end;

v := chr (n+1 + ord('Z'));
lido := trim (lido);
extraiVariavelLonga := true;
end;

{--------------------------------------------------------}
{              extrai uma variavel do comando
{--------------------------------------------------------}

function extraiVariavel (var lido: string; var v: char): boolean;
begin
extraiVariavel := false;

lido := trim (lido);
if lido = '' then
begin exit end;

v := upcase(lido[1]);
if v = '$' then
begin
extraiVariavel := extraiVariavelLonga (lido, v);
exit;
end;

if not (v in ['A'..'Z']) then
begin exit end;
delete (lido, 1, 1);

if (lido <> '') and
(upcase (lido[1]) in ['A'..'Z', '0'..'9']) then
begin exit end;

lido := trim (lido);
extraiVariavel := true;
end;

{--------------------------------------------------------}
{    transforma o lido num parametro string ou variavel
{--------------------------------------------------------}

function extraiValor (var lido: string; var valor: string): boolean;
var tam: integer;
v: char;
x: integer;
label loopAspas;
begin
extraiValor := false;

lido := trim (lido);
if lido = '' then
begin exit end;
valor := '';

if lido[1] in ['0'..'9', '-'] then
begin
repeat
valor := valor + lido[1];
delete (lido, 1, 1);
until (lido = '') or (not (lido[1] in ['0'..'9']));
end
else
if (lido <> '') and (lido[1] = '"') then
begin
valor := '';
loopAspas:
delete (lido, 1, 1);
tam := pos ('"', lido);
if tam = 0 then
begin tam := length (lido)+1 end;
valor := valor + copy (lido, 1, tam-1);
delete (lido, 1, tam);
if (lido <> '') and (lido[1] = '"') then
begin
valor := valor + '"';
goto loopAspas;
end;
end
else
if (lido <> '') and (lido[1]= '$') then
begin
if not extraiVariavelLonga (lido, v) then
begin exit end;
valor := varScript [v];
end
else
if (lido <> '') and (upcase(lido[1]) in ['A'..'Z']) then
begin
valor := varScript [upcase(lido[1])];
delete (lido, 1, 1);
end
else
if (lido <> '') and (lido[1]= '(') then
begin
delete (lido, 1, 1);
if not calculaExpressao (lido, x) then
begin exit end;
valor := intToStr (x);

lido := trim (lido);
if lido[1] <> ')' then
begin exit end;
delete (lido, 1, 1);
end
else
begin exit end;   { erro }

lido := trim (lido);
extraiValor := true;
end;

{--------------------------------------------------------}
{         transforma o lido numero de arquivo
{--------------------------------------------------------}

function extraiNumArq (var lido: string; var arqSel: char): boolean;
begin
extraiNumArq := false;

lido := trim (lido);
if lido = '' then
begin exit end;
arqSel := ' ';

if lido[1] = '#' then
begin
delete (lido, 1, 1);
if (lido = '') or not (lido[1] in ['0'..'9']) then
begin exit end;
arqSel := lido[1];
delete (lido, 1, 1);
end
else
begin exit end;

if (lido <> '') and (copy (lido, 1, 1) <> ' ') then
begin exit end;
while (lido <> '') and (lido[1] = ' ') do
begin delete (lido, 1, 1) end;
extraiNumArq := true;
end;


{--------------------------------------------------------}
{         transforma o lido em um nome de lista
{--------------------------------------------------------}

function extraiNomeLista (var lido: string; var nome: string): boolean;
var i: string;
begin
extraiNomeLista := false;
lido := trim(lido);
if length(lido) <= 1 then
begin exit end;
if not ( lido[1] = '[') then
begin exit end;
delete(lido, 1, 1);
i := '';
while true do
begin
i := copy(lido, 1, 1);
delete(lido, 1, 1);
if i = '' then
begin exit end;
if (i = ']') and (nome <> '') then
begin
extraiNomeLista := true;
break;
end
else
begin
nome := nome + i;
end;
end;
end;

{--------------------------------------------------------}
{ Comando MIDI
{--------------------------------------------------------}

function processaMIDI(lido:string):boolean;
var
canal,nota,volume,timbre,op:integer;
s,comando:string;
begin
op:=0;
processaMIDI:=false;
lido:=trim(lido);
if lido='' then
begin exit end;

lido:=maiuscAnsi(lido);
if (lido='INICIA') and (not MIDIaberto) then
begin {inicia processos MIDI}
phandle:=@handle; InicioMIDI; MIDIaberto:=true;
processaMIDI:=true; exit; end;

if (lido='TERMINA') and MIDIaberto then
begin
MIDIFim; MIDIaberto:=false;
processaMIDI:=true; exit; end;

if (lido='PANE') and MIDIaberto then
begin
for canal:=0 to 15 do
begin for nota:=0 to 127 do
begin NoteOn(canal,nota,0) end end;
processaMIDI:=true; exit; end;

{so pode processar os demais comandos, se MIDI estiver aberto}
if not MIDIaberto then
begin exit end;
comando:=copy(lido,1,2);
delete(lido,1,2);
if lido='' then
begin exit end; {precisa de parametros}

if comando='NL' then
begin op:=1 end {opo 1=Nota Ligada}
else
if comando='ND' then
begin op:=2 end {opo 2=Nota Desligada}
else
if comando='TT' then
begin op:=3 end {opo 3=Troca Timbre}
else
begin exit end; {por enquanto, s estas trs opes}

{se opo vlida, prossegue}
if not extraiValor(lido,s) then
begin exit end; {recebe o primeiro parametro, que  o canal}
canal:=strToInt(s);
if (canal<1) or (canal>16) then
begin exit end; {canais, de 1 a 16}
dec(canal); {internamente, de 0 a 15}
case op of
1:
begin
if not extraiValor(lido,s) then
begin exit end;
nota:=strToInt(s);
if (nota<0) or (nota>127) then
begin exit end;
if not extraiValor(lido,s) then
begin exit end;
volume:=strToInt(s);
if (volume<0) or (volume>127) then
begin exit end;
if lido<>'' then
begin exit end; {nada de abobrinhas no final}
NoteOn(canal,nota,volume); end;
2:
begin
if not extraiValor(lido,s) then
begin exit end;
nota:=strToInt(s);
if (nota<0) or (nota>127) then
begin exit end;
if lido<>'' then
begin exit end; {nada de abobrinhas no final}
NoteOn(canal,nota,0); end;
3:
begin
if not extraiValor(lido,s) then
begin exit end;
timbre:=strToInt(s);
if (timbre<0) or (timbre>127) then
begin exit end;
if lido<>'' then
begin exit end; {nada de abobrinhas no final}
ProgramChange(canal,timbre); end;
end; {case op of}
processaMIDI:=true;
end; {function processaMIDI}

{--------------------------------------------------------}
{                    Comando Debug
{--------------------------------------------------------}

function processaDebug (lido: string): boolean;
begin
if (lido = '-') or
(copy (lido, 1, 1) = 'N') then
begin
debug := false;
sintWriteln (DEBUG_DESLIGADO);
end
else
begin
debug := true;
sintWriteln (DEBUG_LIGADO);
end;

processaDebug := true;
end;

{--------------------------------------------}
{ Avaliador de expresso aritmtica          }
{ Por Antonio Borges e Bernard Condorcet     }
{ Consultor: Antonio Anibal Teles            }
{ Em maro/2007                              }
{--------------------------------------------}

(*      Sintaxe para a expresso aritmtica LL(1)

<Exp> ::= <Term> <s_Exp>
<s_Exp> ::= + <Exp> | - <Exp> | nil
<Term> ::= <Factor> <op_Term>
<op_Term> ::= * <Term> | / <Term> | nil
<Factor> ::= x | y | ... |  ( <Exp> ) |  - <Factor>
*)


function calculaExpressao (var s: string; var v: integer): boolean;
type
TToken = char;  { + - * / ( ) # NIL }

var
first, follow: TToken;
vfollow: integer;

{-----------------------------------}

function calc_Exp (var v: integer): boolean;   forward;
function calc_Term (var v: integer): boolean;  forward;

{-----------------------------------}

procedure nextToken;
var ss, vv: string;
erro: integer;
begin
first := follow;

vfollow := 0;
while (pl <= length (line)) and (line[pl] = ' ') do
begin pl := pl + 1 end;

lastpl := pl;
if pl > length (line) then
begin follow := #$0 end
else
if line[pl] in ['+', '-', '*', '/', '(', ')'] then
begin
follow := line[pl];
pl := pl + 1;
end
else
if line[pl] in ['0'..'9'] then
begin
follow := '#';
repeat
vfollow := (vfollow * 10) + (ord(line[pl]) - ord('0'));
pl := pl + 1;
until (pl > length (line)) or not (line[pl] in ['0'..'9']);
end
else
if upcase(line[pl]) in ['A'..'Z', '$'] then
begin
follow := '#';
ss := line[pl];
if line[pl] = '$' then
begin   // variveis longas
while true do
begin
pl := pl + 1;
if (pl <= length (line)) and
(upcase(line[pl]) in ['A'..'Z', '0'..'9']) then
begin ss := ss + line [pl] end
else
begin break end;
end;
pl := pl - 1;
end;

if not extraiValor (ss, vv) then
begin follow := '?' end
else
begin
val (vv, vfollow, erro);
if erro <> 0 then
begin
follow := '?';
vfollow := 0;
end
else
begin pl := pl + 1 end;
end;
end
else
begin
follow := '?';
pl := pl + 1;
end;
end;

{-----------------------------------}

function calc_factor (var v: integer): boolean;
var op: TToken;
begin
calc_factor := false;
v := 0;
op := follow;

case op of
'#':
begin
v := vfollow;
nextToken;
calc_factor := true;
end;

'-':
begin
nextToken;
if calc_factor (v) then
begin
v := -v;
calc_factor := true;
end;
end;

'(':
begin
nextToken;
if calc_exp (v) then
begin if follow = ')' then
begin
calc_factor := true;
nextToken;
end end;
end;
end;
end;

{-----------------------------------}

function calc_Term (var v: integer): boolean;
var v1, v2: integer;
op: char;
begin
calc_Term := false;
if calc_factor (v1) then
begin
calc_Term := true;
op := follow;
v := v1;
while (op = '*') or (op = '/') do
begin
nextToken;
if calc_factor (v2) then
begin
case op of
'*':
begin v := v1 * v2 end;
'/':
begin v := v1 div v2 end;
end;
end
else
if (follow = '*') or (follow = '/') then  // evita ** e outros
begin
calc_Term := false;
exit;
end;
op := follow;
v1 := v;
end;
end;
end;

{-----------------------------------}

function calc_Exp (var v: integer): boolean;
var v1, v2: integer;
op: char;
begin
calc_Exp := false;
if calc_term (v1) then
begin
calc_Exp := true;
op := follow;
v := v1;
while (op = '+') or (op = '-') do
begin
nextToken;
if calc_term (v2) then
begin
case op of
'+':
begin v := v1 + v2 end;
'-':
begin v := v1 - v2 end;
end;
end
else
if (follow = '-') or (follow = '-') then  // evita ++. -- e outros
begin
calc_Exp := false;
exit;
end;
op := follow;
v1 := v;
end;
end;
end;

{-----------------------------------}

var ok: boolean;
begin
line := s;
pl := 1;
lastpl := pl;
nextToken;
v := 0;
ok := calc_Exp (v); {and (follow = #$0)}
s := copy (s, lastpl, 9999);
calculaExpressao := ok;
end;

{--------------------------------------------------------}
{                   comando seja
{--------------------------------------------------------}

function processaRandomiza (lido: string): boolean;
begin
processaRandomiza := false;
if lido <> '' then
begin exit end;

randomize;
processaRandomiza := true;
end;

{--------------------------------------------------------}
{                   comando seja
{--------------------------------------------------------}

function processaSeja (lido: string): boolean;
var v: char;
i, p, nc: integer;
r: longint;
erro: integer;
s, fun, valor, busc: string;
ano, mes, dia, semana: word;
hora, minuto, segundo, cent: word;
ndias: integer;
tempo: longint;
{$IFDEF VER150}
date_and_time: TDateTime;
{$ENDIF}

const
tabSemana: array [0..6] of string[9] =
('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado');
begin
processaSeja := false;
if not extraiVariavel (lido, v) then
begin exit end;
if lido = '' then
begin exit end;

if lido[1] = '=' then    {sinal de igual  opcional }
begin
delete (lido, 1, 1);
lido := trim (lido);
end;

if lido = '' then
begin exit end;

{funo params, passa os argumentos da linha de comando para o script.}
if maiuscAnsi (lido) = 'PARAMS' then
begin
if ParamCount>1 then
begin str((ParamCount-1),s) end
else
begin s:='0' end;
for i:=2 to ParamCount do
begin {concatena os parametros}
s:=s+' ';
s:=s+ParamStr(i);
end; {concatena os parametros}
varScript[v]:=s;
processaSeja:=true;
exit;
end; {funo params}

if maiuscAnsi (lido) = 'DATA' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano, mes, dia);
{$ELSE}
getDate(ano, mes, dia, semana);
{$ENDIF}
str (dia, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := s;
str (mes, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := valor + '/' + s;
str (ano, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := valor + '/' + s;
varScript[v] := valor;
processaSeja := true;
exit;
end;

if maiuscAnsi (lido) = 'HORA' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeTime (date_and_time, hora, minuto, segundo, cent);
{$ELSE}
gettime (hora, minuto, segundo, cent);
{$ENDIF}
str (hora, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := s;
str (minuto, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := valor + ':' + s;
str (segundo, s);
if length (s) = 1 then
begin s := '0' + s end;
valor := valor + ':' + s;
varScript[v] := valor;
processaSeja := true;
exit;
end;

if maiuscAnsi (lido) = 'DIA' then
begin
{$IFDEF VER150}
date_and_time := now;
semana := dayOfTheWeek (date_and_time);
{$ELSE}
getDate(ano, mes, dia, semana);
{$ENDIF}

varScript[v] := tabSemana[semana];
processaSeja := true;
exit;
end;

if maiuscAnsi (lido) = 'TEMPO' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano, mes, dia);
semana := dayOfTheWeek (date_and_time);
decodeTime (date_and_time, hora, minuto, segundo, cent);
{$ELSE}
getDate(ano, mes, dia, semana);
gettime (hora, minuto, segundo, cent);
{$ENDIF}

ndias := semana - semana0;
if ndias < 0 then
begin ndias := ndias + 7 end;
hora := hora + ndias*24;

tempo := ((hora*60+minuto)*60+segundo)*100+cent;
tempo := tempo - tempo0;

str (tempo, varScript[v]);
processaSeja := true;
exit;
end;

nc := 0;
if maiuscAnsi (copy (lido, 1, 8)) = 'TAMANHO ' then
begin nc := 8 end
else
if maiuscAnsi (copy (lido, 1, 7)) = 'MAIUSC ' then
begin nc := 7 end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'TRIM ' then
begin nc := 5 end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'POS ' then
begin nc := 4 end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'RAND ' then
begin nc := 5 end
else
if maiuscAnsi (copy (lido, 1, 8)) = 'PALAVRA ' then
begin nc := 8 end
else
if maiuscAnsi(copy(lido,1,4))='CHR ' then
begin nc:=4 end
else
if maiuscAnsi(copy(lido,1,4))='ASC ' then
begin nc:=4 end;

if nc <> 0 then
begin
fun := maiuscAnsi (copy (lido, 1, nc-1));
delete (lido, 1, nc);
lido := trim (lido);

if (fun = 'POS') or (fun = 'PALAVRA') then
begin if not extraiValor (lido, busc) then
begin exit end end;

if not extraiValor (lido, valor) then
begin exit end;
if lido <> '' then
begin exit end;
if fun='ASC' then
begin if (length(valor)<>1) then
begin varScript[v]:='' end
else
begin
str(ord(valor[1]),valor);
varScript[v]:='#'+valor;
end end
else
if fun='CHR' then
begin varScript[v]:=processaCHR(valor) end
else
if fun = 'TAMANHO' then
begin str (length(valor), varScript[v]) end
else
if fun = 'MAIUSC' then
begin varScript[v] := maiuscAnsi (valor) end
else
if fun = 'TRIM' then
begin
valor := trim (valor);
varScript[v] := valor;
end
else
if fun = 'POS' then
begin str (pos (busc, valor), varScript[v]) end
else
if fun = 'RAND' then
begin
val (valor, r, erro);
if erro <> 0 then
begin exit end;
str (random (r), varScript[v])
end
else
if fun = 'PALAVRA' then
begin
val (busc, r, erro);
if erro <> 0 then
begin exit end;
if r < 1 then
begin exit end;
for i := 1 to r-1 do
begin
p := pos (' ', valor);
if p <> 0 then
begin
delete (valor, 1, p);
valor := trim (valor);
end
else
begin valor := '' end;
end;

p := pos (' ', valor);
if p <> 0 then
begin delete (valor, p, 999) end;
varScript[v] := valor;
end
end
else
begin
if lido[1] = '"' then
begin
if not extraiValor (lido, valor) then
begin exit end;
varScript[v] :=  valor;
end
else
begin
if not extraiValor(lido, valor) then
begin exit end;
varScript[v] := valor;
end
end;

if trim (lido) = '' then
begin processaSeja := true end;
end;

function processaCHR(recebido:string):string;
var
r,erro:integer;
begin
if (length(recebido)>4) and (recebido[4]='#') then
begin {,fr um cdigo retornado por l tecla}
for r:=1 to 3 do
begin if (pos(recebido[r],'01')=0) then
begin processaCHR:=''; exit; end end; {,s pode ser 0 ou 1}
recebido:=copy(recebido,4,length(recebido)); {,retira as flags iniciais}
end {se for cdigo retornado por l tecla}
else
if recebido[1]<>'#' then
begin processaCHR:=''; exit; end; {tem que comear com cardinal}
delete(recebido,1,1); {elimina o cardinal}
if recebido[1]='0' then
begin processaCHR:=''; exit; end; {no pode comear com 0}
val(recebido,r,erro);
if erro<>0 then
begin processaCHR:=''; exit; end; {no pde converter}
processaCHR:=chr(r);
end; {function processaCHR}

{--------------------------------------------------------}
{                   comando soma
{--------------------------------------------------------}

function processaSoma (lido: string): boolean;
var v: char;
s, norig: string;
n, o: longint;
erro: integer;
valor: string;
begin
processaSoma := false;

if not extraiVariavel (lido, v) then
begin exit end;
if lido = '' then
begin exit end;

if not extraiValor (lido, valor) then
begin exit end;
val (valor, n, erro);
if erro <> 0 then
begin exit end;

norig := '';
s := varScript[v];
while (s <> '') and (s[length (s)] in ['0'..'9']) do
begin
norig := s[length(s)] + norig;
delete (s, length(s), 1);
end;
if (s <> '') and (s[length (s)] = '-') then
begin
norig := s[length(s)] + norig;
delete (s, length(s), 1);
end;
val (norig, o, erro);

str (o+n, norig);
varScript[v] := s + norig;

processaSoma := true;
end;

{--------------------------------------------------------}
{           comandos subtrai, multiplica, divide
{--------------------------------------------------------}

function processaContas (lido: string; operador: char): boolean;
var v: char;
norig: string;
n, o: longint;
erro: integer;
valor: string;
begin
processaContas := false;

if not extraiVariavel (lido, v) then
begin exit end;
if lido = '' then
begin exit end;

val (varScript[v], o, erro);
if erro <> 0 then
begin exit end;

if not extraiValor (lido, valor) then
begin exit end;
val (valor, n, erro);
if erro <> 0 then
begin exit end;

case operador of
'+':
begin str (o+n, norig) end;
'-':
begin str (o-n, norig) end;
'*':
begin str (o*n, norig) end;
'/':
begin
if n = 0 then
begin
sintWriteln (DIVISAO_ZERO);  {'Diviso por zero'}
exit;
end;
str (o div n, norig);
end;
end;

varScript[v] := norig;

if lido <> '' then
begin exit end;
processaContas := true;
end;

{--------------------------------------------------------}
{                   comando concatena
{--------------------------------------------------------}

function processaConcatena (lido: string): boolean;
var v: char;
valor: string;
begin
processaConcatena := false;

if not extraiVariavel (lido, v) then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
if lido <> '' then
begin exit end;

varScript[v] := varScript[v] + valor;

processaConcatena := true;
end;

{--------------------------------------------------------}
{                  comando copia
{--------------------------------------------------------}

function processaCopia (lido: string): boolean;
var vdest, vorig: char;
c1, c2: string;
i1, i2, erro: integer;
begin
processaCopia := false;
if not extraiVariavel (lido, vdest) then
begin exit end;
if not extraiVariavel (lido, vorig) then
begin exit end;

if not extraiValor (lido, c1) then
begin exit end;
if not extraiValor (lido, c2) then
begin exit end;
c1 := trim(c1);
c2 := trim(c2);

val (c1, i1, erro);
if erro <> 0 then
begin exit end;
val (c2, i2, erro);
if erro <> 0 then
begin exit end;

varScript[vdest] := copy (varScript[vorig], i1, (i2-i1+1));
processaCopia := true;
end;

{--------------------------------------------------------}
{                  comando deleta
{--------------------------------------------------------}

function processaDeleta (lido: string): boolean;
var vorig: char; txt: string;
c1, c2: string;
i1, i2, erro: integer;
begin
processaDeleta := false;
if not extraiVariavel (lido, vorig) then
begin exit end;
if not extraiValor (lido, c1) then
begin exit end;
if not extraiValor (lido, c2) then
begin exit end;
c1 := trim(c1);
c2 := trim(c2);

val (c1, i1, erro);
if erro <> 0 then
begin exit end;
val (c2, i2, erro);
if erro <> 0 then
begin exit end;
txt := varScript[vorig];
delete(txt, i1, i2);
varScript[vorig] := txt;
processaDeleta := true;
end;

{--------------------------------------------------------}
{                  comando substitui
{--------------------------------------------------------}

function processaSubstitui (lido: string): boolean;
var vorig: string;
v: char;
c1, c2: string;
i: integer;
begin
processaSubstitui := false;
if not extraiVariavel (lido, v) then
begin exit end;
if not extraiValor (lido, c1) then
begin exit end;
if not extraiValor (lido, c2) then
begin exit end;

vorig := varScript[v];
for i := length(vorig)-length(c1)+1 downto 1 do
begin if copy(vorig, i, length(c1)) = c1 then
begin
delete (vorig, i, length(c1));
insert (c2, vorig, i);
end end;

varScript[v] := vorig;
processaSubstitui := true;
end;

{--------------------------------------------------------}
{                  comando toca
{--------------------------------------------------------}

function processaToca (lido: string): boolean;
var
retornoMci: array [0..255] of char;
ficaTocando: boolean;
nomeArq: string;

procedure sendString (s: string);
var p: array [0..255] of char;
begin
strPcopy (p, s);
mciSendString (p, retornoMci, 255, 0);
end;

procedure toca (nomeArq: string; ficaTocando: boolean);
begin
if ficaTocando then
begin sendString ('play ' + nomeArq) end
else
begin
sendString ('open "' + nomearq + '" alias myfile');
sendString ('play myfile');
repeat
delay (100);
sendString ('status myfile mode');
until keypressed or (strPas (retornoMci) <> 'playing');
while keypressed do
begin readkey end;

sendString ('stop myfile');
sendString ('close myfile');
end;
end;

begin
processaToca := false;
ficaTocando := false;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
ficaTocando := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then
begin exit end;
if lido <> '' then
begin exit end;

toca (nomeArq, ficaTocando);
processaToca := true;
end;

{--------------------------------------------------------}
{                  comando mci
{--------------------------------------------------------}

function processaMci (lido: string): boolean;
var
cmd: string;
retornoMci: array [0..255] of char;
v: char;

procedure sendString (s: string);
var p: array [0..255] of char;
begin
strPcopy (p, s);
mciSendString (p, retornoMci, 255, 0);
end;

begin
processaMci := false;

if not extraiVariavel (lido, v) then
begin exit end;
if not extraiValor (lido, cmd) then
begin exit end;
if lido <> '' then
begin exit end;

sendString (cmd);
varScript[v] := strPas (retornoMci);
processaMci := true;
end;

{--------------------------------------------------------}
{                  comando abre
{--------------------------------------------------------}

function processaAbre (lido: string): boolean;
var arqSel: char;
adiciona: boolean;
nomeArq: string;

label erro;
begin
processaAbre := true;
adiciona := false;
nomeArq := '';

if (lido <> '') and (lido [length(lido)] = '&') then
begin
adiciona := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if not extraiNumArq (lido, arqSel) then
begin goto erro end;

if lido = '' then
begin goto erro end;

if not extraiValor (lido, nomeArq) then
begin goto erro end;
if nomeArq = '' then
begin goto erro end;

with arquivo [arqsel] do
begin
assign (arq, nomeArq);
{$I-}
if adiciona then
begin
append (arq);
if ioresult <> 0 then
begin rewrite (arq) end;
end
else
begin reset (arq) end;
if ioresult <> 0 then
begin goto erro end;
{$I+}

aberto := true;
internet := false;
end;

exit;

erro:
sintWriteln (ERRO_ABRE + ' ' + nomearq);  {'Erro na abertura do arquivo'}
processaAbre := false;
end;

{--------------------------------------------------------}
{                  comando Internet
{--------------------------------------------------------}

function processaInternet (lido: string): boolean;
begin
processaInternet := true;
if maiuscAnsi (lido) = 'INICIA' then
begin abreWinSock end
else
if maiuscAnsi (lido) = 'TERMINA' then
begin fechaWinSock end
else
begin processaInternet := false end;
end;
{--------------------------------------------------------}
{                  comando Conecta
{--------------------------------------------------------}

function processaConecta (lido: string): boolean;
var arqSel: char;
ignoraErro: boolean;
nomeComput, portaComput: string;
porta: word;
cod: integer;
label erro, erro2;
begin
processaConecta := true;

ignoraErro := false;
if (copy(lido, length(lido), 1) = '&') then
begin
delete(lido, length(lido), 1);
ignoraErro := true;
end;

if not extraiNumArq (lido, arqSel) then
begin goto erro end;

if lido = '' then
begin goto erro end;

if not extraiValor (lido, nomeComput) then
begin goto erro end;
if not extraiValor (lido, portaComput) then
begin goto erro end;

val (portaComput, porta, cod);
if cod <> 0 then
begin goto erro2 end;

with arquivo [arqSel] do
begin
soquete := abreConexao (nomeComput, porta);
if soquete < 0 then
begin goto erro end;

pBuf := inicBufRede (soquete);
internet := true;
aberto := true;
end;
if ignoraErro then
begin statusULTIO := 0 end;
exit;

erro:
if not ignoraErro then
begin
sintWriteln (ERRO_CONEXAO);  {'Erro de conexao'}
processaConecta := false;
exit;
end
else
begin
statusUltIO := 1;
exit;
end;

erro2:
if not ignoraErro then
begin
sintWriteln (ERRO_PORTA);  {'Erro na porta TCP/IP'}
processaConecta := false;
end
else
begin
processaConecta := true;
statusUltIO := 2;
end;
end;

{--------------------------------------------------------}
{                  comando Serve
{--------------------------------------------------------}

function processaServe (lido: string): boolean;
var arqSel: char;
portaComput: string;
porta: word;
soq: longint;
cod: integer;
label erro, erro2;
begin
processaServe := true;

if not extraiNumArq (lido, arqSel) then
begin goto erro end;

if lido = '' then
begin goto erro end;
if not extraiValor (lido, portaComput) then
begin goto erro end;
val (portaComput, porta, cod);
if cod <> 0 then
begin goto erro2 end;

with arquivo [arqSel] do
begin
soq := escutaConexao (porta);
if soq < 0 then
begin goto erro end;
soquete := aceitaConexao (soq);
fechaConexao (soq);
if soquete < 0 then
begin goto erro end;

pBuf := inicBufRede (soquete);
internet := true;
aberto := true;
end;
exit;

erro:
sintWriteln (ERRO_CONEXAO);  {'Erro de conexao'}
processaServe := false;
exit;

erro2:
sintWriteln (ERRO_PORTA);  {'Erro na porta TCP/IP'}
processaServe := false;
end;

{--------------------------------------------------------}
{                  comando observa
{--------------------------------------------------------}

function processaObserva (lido: string): boolean;
var arqSel: char;
v: char;
teclado: boolean;
begin
processaObserva := false;
teclado := false;
if maiuscAnsi (copy (lido, 1, 8)) = 'TECLADO ' then
begin
teclado := true;
delete (lido, 1, 8);
end
else
if not extraiNumArq (lido, arqSel) then
begin exit end;

lido := trim (lido);
if not extraiVariavel (lido, v) then
begin exit end;
if lido <> '' then
begin exit end;

if teclado then
begin varScript[v] := chr (ord (keypressed) + ord ('0')) end
else
begin with arquivo [arqsel] do
begin
if (not aberto) or (not internet) then
begin varScript[v] := '0' end
else
begin str (integer(temDadoBufRede (pbuf)), varScript[v]) end;
end end;

processaObserva := true;
end;

{--------------------------------------------------------}
{                  comando Checa
{--------------------------------------------------------}

function processaCheca (lido: string): boolean;
var
v: char;
begin
processaCheca := false;
if not extraiVariavel (lido, v) then
begin exit end;
if lido <> '' then
begin exit end;

str (statusUltIO, varScript[v]);
processaCheca := true;
end;

{--------------------------------------------------------}
{                  comando Fecha
{--------------------------------------------------------}

function processaFecha (lido: string): boolean;
var arqSel: char;
label erro;
begin
if not extraiNumArq (lido, arqSel) then
begin goto erro end;

with arquivo [arqsel] do
begin
{$I-}
if aberto then
begin if internet then
begin
fimBufRede (pbuf);
fechaConexao (soquete);
end
else
begin close (arq) end end;
{$I+}
aberto := false;
end;

if ioresult <> 0 then
begin goto erro end;

processaFecha := true;
exit;

erro:
sintWriteln (ERRO_FECHA);  {'Erro no fechamento do arquivo'}
processaFecha := false;
end;

{--------------------------------------------------------}
{                  comando soletra
{--------------------------------------------------------}

function processaSoletra(lido: string) :boolean;
var v: string;
begin
processaSoletra := false;
if lido = '' then
begin exit end;
extraiValor(lido, v);
sintSoletra (v);
write(v);
while sintFalando do
begin waitMessage end;
processaSoletra := true;
end;

{--------------------------------------------------------}
{                  comando titulo
{--------------------------------------------------------}

function processaTitulo(lido: string): boolean;
var v: array[0..300] of char; tit: string;
begin
processaTitulo := false;
if lido = '' then
begin exit end;
extraiValor(lido, tit);
strPCopy(v, tit);
setWindowText (crtWindow, v);
processaTitulo := true;
end;

{--------------------------------------------------------}
{ Procura uma lista por nome e retorna o ponteiro
{--------------------------------------------------------}

function procuraLista (lista: string): pListaRec;
var i: integer;
begin
procuraLista := nil;
for i := 0 to 19 do
begin
if varLista[i] = nil then
begin continue end;
if varlista[i]^.nome = lista then
begin procuraLista := varLista[i] end;
end;
end;

{--------------------------------------------------------}
{ Verifica se h espaos vazios na varivel das listas
{--------------------------------------------------------}

function espacoVazioVarLista: integer;
var i: integer;
begin
espacoVazioVarLista := -1;
for i := 0 to 19 do
begin
if varLista[i] = nil then
begin
espacoVazioVarLista := i;
break;
end;
end;
end;

{--------------------------------------------------------}
{                  comando lista
{--------------------------------------------------------}

function processaLista(lido: string): boolean;
var v: string;
p: pListaRec;
i, i2: integer;
c: char;
begin
processaLista := false;
if not (extraiNomeLista(lido, v)) then
begin exit end;
lido := trim(lido);
if maiuscAnsi(copy(lido, 1, 4)) = 'CRIA' then
begin
delete(lido, 1, 4);
lido := trim(lido);
{ S para verificar a sintaxe }
if lido <> '' then
begin exit end;
if (procuraLista(v)) <> nil then
begin
sintWriteln(LISTA_JA_EXISTE);
exit;
end;
i := espacoVazioVarLista;
if i = -1 then
begin
sintWriteln(MUITAS_LISTAS);
exit;
end;
varLista[i] := criaLista;
varLista[i].nome := v;
end
else
if maiuscAnsi(copy(lido, 1, 5)) = 'APAGA' then
begin
delete(lido, 1, 5);
lido := trim(lido);
{ S para verificar a sintaxe }
if lido <> '' then
begin exit end;
p := procuraLista(v);
for i := 0 to 19 do
begin
if varLista[i] = p then
begin varLista[i] := nil end;
end;
if p = nil then
begin exit end;
zeraLista (p);
p := nil;
end
else
if maiuscAnsi(copy(lido, 1, 7)) = 'TAMANHO' then
begin
delete(lido, 1, 7);
p := procuraLista(v);
if p= nil then
begin exit end;
if not extraiVariavel(lido, c) then
begin exit end;
varScript[c] := inttostr(p^.lista.Count);
end
else
if maiuscAnsi(copy(lido, 1, 4)) = 'ITEM' then
begin
delete(lido, 1, 4);
p := procuraLista(v);
if p= nil then
begin exit end;
if not extraiValor(lido, v) then
begin exit end;
val(v, i, i2);
if i2 <> 0 then
begin exit end;
if not extraiVariavel(lido, c) then
begin exit end;
try
varScript[c] := p^.lista[i];
except
exit;
end;
end
else
if maiuscAnsi(copy(lido, 1, 8)) = 'ADICIONA' then
begin
delete(lido, 1, 8);
p := procuraLista(v);
if p= nil then
begin exit end;
if not extraiValor(lido, v) then
begin exit end;
try
p^.lista.add(v);
except
exit;
end;
end
else
if maiuscAnsi(copy(lido, 1, 6)) = 'DELETA' then
begin
delete(lido, 1, 6);
p := procuraLista(v);
if p= nil then
begin exit end;
if not extraiValor(lido, v) then
begin exit end;
i := p^.lista.indexOf(v);
if i < 0 then
begin exit end;
try
p^.lista.Delete(i);
except
exit;
end;
end
else
begin exit end;
processaLista := true;
end;

{--------------------------------------------------------}
{                  comando escreve
{--------------------------------------------------------}

function processaEscreve (lido: string): boolean;
var pulaLinha: boolean;
arqSel: char;
mudo: boolean;
valor: string;
p: pchar;
saida: string;

function escreveArq (s: string; pulando: boolean): boolean;
label erro;
begin
escreveArq := false;

if arqSel = ' ' then
begin
if pulando then
begin writeln (s) end
else
begin write (s) end;
if not mudo then
begin sintetiza (s) end;
end
else
begin with arquivo[arqSel] do
begin
if not aberto then
begin goto erro end;
if not internet then
begin
{$I-}
if pulando then
begin writeln (arq, s) end
else
begin write (arq, s) end;
{$I+}
statusUltIO := ioresult;
end
else
begin
if pulando then
begin s := s + #$0d + #$0a end;
p := @s[1];
statusUltIO := ord (send (soquete, p^, length (s), 0) > 0);
end;
end end;

escreveArq := true;
exit;

erro:
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
end;

begin
statusUltIO := 0;
processaEscreve := false;
mudo := false;

pulaLinha := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
pulaLinha := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

arqSel := ' ';
if (lido <> '') and (lido[1] = '#') then
begin
delete (lido, 1, 1);
if (lido = '') or not (lido[1] in ['0'..'9']) then
begin
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
exit;
end;
arqSel := lido[1];
delete (lido, 1, 1);
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'MUDO' then
begin
delete (lido, 1, 4);
mudo := true;
end;

lido := trim (lido);
if lido = '' then
begin escreveArq ('', true) end
else
begin
saida := '';
while extraiValor (lido, valor) do
begin saida := saida + valor end;
escreveArq (saida, pulaLinha);
if lido <> '' then
begin exit end;
end;

while sintFalando do
begin end;
processaEscreve := true;
end;

{--------------------------------------------------------}
{                  comando fala
{--------------------------------------------------------}

function processaFala (lido: string): boolean;
var
esperando: boolean;
valor: string;
saida: string;

begin
processaFala := false;

esperando := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
esperando := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if lido = '' then
begin
sintPara;
if esperando then
begin while sintFalando do
begin waitMessage end end;
processaFala := true;
exit;
end;

saida := '';
while extraiValor (lido, valor) do
begin saida := saida + valor end;
sintetiza (saida);

if esperando then
begin while sintFalando do
begin waitMessage end end;

if lido = '' then
begin processaFala := true end;
end;

{--------------------------------------------------------}
{                  comando falahora
{--------------------------------------------------------}

function processaFalaHora (lido: string): boolean;
var v, hora, minuto: string;
begin
processaFalaHora := false;
if lido = '' then
begin exit end;
extraiValor(lido, v);
if (length(v)>5) or (length(v)<5) then
begin exit end;
if not (copy(v, 3, 1)=':') then
begin exit end;
hora := copy(v, 1, 2);
minuto := copy(v, 4, 5);
falaHoraQualquer(strToInt(hora), strToInt(minuto));
while sintFalando do
begin waitMessage end;
processaFalaHora := true;
end;

{--------------------------------------------------------}
{                  comando bipa
{--------------------------------------------------------}

function processaBipa (lido: string): boolean;
var tipo: string;
begin
processaBipa := false;

if lido = '' then
begin tipo := '0' end
else
if not extraiValor (lido, tipo) then
begin exit end;

if tipo = '1' then
begin sintClek end
else
begin sintBip end;

processaBipa := true
end;

{--------------------------------------------------------}
{                  comando cor
{--------------------------------------------------------}

function processaCor (lido: string): boolean;
var valor: string;
cor, erro: integer;
begin
processaCor := false;

if lido = '' then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, cor, erro);
if erro <> 0 then
begin exit end;

textColor (cor);

processaCor := true
end;

{--------------------------------------------------------}
{                  comando Fundo
{--------------------------------------------------------}

function processaFundo (lido: string): boolean;
var valor: string;
cor, erro: integer;
begin
processaFundo := false;

if lido = '' then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, cor, erro);
if erro <> 0 then
begin exit end;

textBackground (cor);

processaFundo := true
end;

{--------------------------------------------------------}
{                     comando Tela
{--------------------------------------------------------}

function processaTela (lido: string): boolean;
var
p, x, y, erro: integer;
s: string;
begin
processaTela := false;
if lido = '' then
begin exit end;

lido := maiuscAnsi (lido);
if (length (lido) = 1) and (upcase(lido[1]) in ['A'..'Z']) then
begin lido := varScript[upcase(lido[1])] end;

if lido = 'LIMPA' then
begin clrscr end
else
if lido = 'MINIMIZADA' then
begin showWindow (crtWindow, SW_HIDE) end
else
if lido = 'NORMAL' then
begin
showWindow (crtWindow, SW_RESTORE);
bringWindowToTop (crtWindow);
end
else
if (lido <> '') and (lido [1] = '@') then
begin
delete (lido, 1, 1);
p := pos (',', lido);
s := copy (lido, 1, p-1);
s := trim(s);
delete (lido, 1, p);
lido := trim (lido);

val (s, x, erro);
if erro <> 0 then
begin exit end;
val (lido, y, erro);
if erro <> 0 then
begin exit end;

gotoxy (x, y);
end
else
begin exit end;

processaTela := true;
end;

{--------------------------------------------------------}
{                  comando remove
{--------------------------------------------------------}

function processaRemove (lido: string): boolean;
var
nomeArq: string;
arq: file;
ignoraErro: boolean;

begin
processaRemove := false;
if lido = '' then
begin exit end;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then
begin exit end;
if nomeArq = '' then
begin exit end;

assign (arq, nomearq);
{$I-}  erase (arq);  {$I+}
if (ioresult <> 0) and not (ignoraErro) then
begin
sintWriteln (ERRO_APAGA + nomeArq);
exit;
end;

processaRemove := true;
end;

{--------------------------------------------------------}
{                  le a posio do mouse
{--------------------------------------------------------}

function lePosMouse (lido: string): boolean;
var
pt: TPOINT;
rect: TRECT;
xorig, yorig: integer;
v1, v2: char;
begin
lePosMouse:= false;
getCursorPos (pt);

if maiuscAnsi (copy (lido, 1, 4)) = 'TELA' then
begin
xorig := 0;
yorig := 0;
delete (lido, 1, 4);
lido := trim (lido);
end
else
begin
getWindowRect (getForegroundWindow, rect);
xorig := rect.left+getSystemMetrics (SM_CXFRAME);
yorig := rect.top+SM_CYCAPTION;
end;

if not extraiVariavel (lido, v1) then
begin exit end;
str (pt.x-xorig, varScript[v1]);
if not extraiVariavel (lido, v2) then
begin exit end;
str (pt.y-yorig, varScript[v2]);
if lido <> '' then
begin exit end;

lePosMouse:= true;
end;

{--------------------------------------------------------}
{                      comando le
{--------------------------------------------------------}

function processaLe (lido: string): boolean;
var
p:integer;
c: char;
s: string;
leLetra, leDeArquivo, editando, mudo, senha, letecla: boolean;
arqSel: char;
varDestino: char;
salvaCor: word;
flags:string;

label erro;

begin
statusUltIO := 0;
mudo := false;
senha := false;
editando := false;
letecla:=false;
lido := trim (lido);
if lido = '' then
begin
readln;
processaLe := true;
exit;
end;

if (maiuscAnsi (copy (lido, 1, 6)) = 'MOUSE ') or
(maiuscAnsi (copy (lido, 1, 5)) = 'RATO ') then
begin
delete (lido, 1, 5);
lido := trim (lido);
processaLe := lePosMouse (lido);
exit;
end;

p:=pos('TECLA ',maiuscAnsi(lido));
if p>0 then
begin
delete(lido,p,6);
lido:=trim (lido);
if lido[length(lido)]<>'&' then
begin lido:=lido+'&' end;
letecla:=true;
end;

processaLe := false;

leLetra := false;
if lido [length(lido)] = '&' then
begin
leLetra := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if lido = '' then
begin
readkey;
processaLe := true;
exit;
end;

leDeArquivo := false;
if lido [1] = '#' then
begin
if not extraiNumArq (lido, arqSel) then
begin exit end;
if lido = '' then
begin goto erro end;
leDeArquivo := true;
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'EDITA' then
begin
delete (lido, 1, 5);
editando := true;
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'MUDO' then
begin
delete (lido, 1, 4);
mudo := true;
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'SENHA' then
begin
delete (lido, 1, 5);
mudo := true;
senha := true;
end;

lido := trim (lido);
if not extraiVariavel(lido,varDestino) then
begin exit end;

if leDeArquivo then
begin with arquivo[arqSel] do
begin
if internet then
begin
statusUltIO := ord (not readlnBufRede (pbuf, s, 30));
end
else
begin
if eof (arq) then
begin statusUltIO := 1 end
else
begin
{$I-} readln (arq, s); {$I+}
statusUltIo := ioresult;
end
end
end end
else
begin
if leLetra then
begin
if mudo then
begin c:=readKey end
else
begin c := sintReadkey end;
if (c>=' ') then
begin if letecla then
begin
str(ord(c),s);
flags:=getflags;
s:=flags+'#'+s; end
else
begin s:=c end end
else
if c=#$0 then
begin
c:=readkey;
str(ord(c),s);
s:='#0#'+s;
if letecla then
begin
flags:=getflags;
s:=flags+s; end;
end
else
begin
str (ord(c),s);
s:='#'+s;
if letecla then
begin
flags:=getflags;
s:=flags+s; end;
end;
end
else
begin
salvaCor := textAttr;
if senha then
begin textAttr := 0 end;
if mudo then
begin readln (s) end
else
if editando then
begin
s := varScript[varDestino];
c := sintEdita (s, wherex, wherey, 80, true);
if c = ESC then
begin s := '' end;
end
else
begin sintReadln (s) end;
textAttr := salvaCor;
end;
end;

varScript[varDestino] := s;
processaLe := true;

exit;

erro:
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
end;

{--------------------------------------------------------}
{                  comando cmd
{--------------------------------------------------------}

function processaCmd (lido: string): boolean;   {recursivo, provavelmente}
var s: string;
begin
processaCmd := false;

if not extraiValor (lido, s) then
begin exit end;
if lido <> '' then
begin exit end;

processaCmd := cmdScript (s);
end;

{--------------------------------------------------------}
{                  Comando espera
{--------------------------------------------------------}

function processaEspera (lido: string): boolean;
var
milisegundos: boolean;
erro: integer;
i, n: longint;
s, nomeJan: string;
titulo: array [0..250] of char;
begin
milisegundos := false;
processaEspera := false;
if lido = '' then
begin exit end;
statusUltIO := 0;

if (maiuscAnsi(copy(lido, 1, 12)) = 'MILISEGUNDOS') then
begin
delete(lido, 1, 12);
milisegundos := true;
end;

if not extraiValor (lido, s) then
begin exit end;
val (s, n, erro);
if erro <> 0 then
begin exit end;

processaEspera := true;

lido := trim (lido);
if lido = '' then
begin
if not milisegundos then
begin delay(n*1000) end
else
begin delay (n) end;
exit;
end;

if not extraiValor (lido, nomeJan) then
begin exit end;
nomeJan := maiuscAnsi (nomeJan);

n := n * 2;
for i := 1 to n do
begin
getWindowText (getForegroundWindow, titulo, 250);
if pos (nomeJan, maiuscAnsi (strPas (titulo))) <> 0 then
begin exit end;
delay (500);
end;

statusUltIO := 1;   { no chegou... }
end;

{--------------------------------------------------------}
{                  Comando digita
{--------------------------------------------------------}

function processaDigita (lido: string): boolean;
var s: string;
poeEnter: boolean;
begin
processaDigita := false;

poeEnter := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
poeEnter := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, s) then
begin exit end;
if lido <> '' then
begin exit end;

keyboardString (s, 100);
if poeEnter then
begin keyboardVirtKey (VK_RETURN, false, false, false, 100) end;

processaDigita := true;
end;

{--------------------------------------------------------}
{                  Comando aciona
{--------------------------------------------------------}

function processaAciona (lido: string): boolean;
var s: string;
letra: char;
n, erro: integer;
comCtl, comShift, comAlt: boolean;

begin
processaAciona := false;
if not extraiValor (lido, s) then
begin exit end;
if s = '' then
begin exit end;
if lido <> '' then
begin exit end;

if length (s) = 1 then
begin keyboardClick (s[1]) end
else
begin
s := maiuscAnsi (s);

comCtl := false;
if copy (s, 1, 5) = 'CTRL+' then
begin
comCtl := true;
delete (s, 1, 5);
end;
comShift := false;
if copy (s, 1, 6) = 'SHIFT+'   then
begin
comShift := true;
delete (s, 1, 6);
end;

comAlt := false;
if copy (s, 1, 4) = 'ALT+'     then
begin
comAlt := true;
delete (s, 1, 4);
end;

if s = '' then
begin exit end;

if s = 'UP'        then
begin n := VK_UP end
else
if s = 'DOWN'      then
begin n := VK_DOWN end
else
if s = 'LEFT'      then
begin n := VK_LEFT end
else
if s = 'RIGHT'     then
begin n := VK_RIGHT end
else
if s = 'ESCAPE'    then
begin n := VK_ESCAPE end
else
if s = 'ESC'       then
begin n := VK_ESCAPE end
else
if s = 'ENTER'     then
begin n := VK_RETURN end
else
if s = 'RETURN'    then
begin n := VK_RETURN end
else
if s = 'BACKSPACE' then
begin n := VK_BACK end
else
if s = 'TAB'       then
begin n := VK_TAB end
else
if s = 'F1'        then
begin n := VK_F1 end
else
if s = 'F2'        then
begin n := VK_F2 end
else
if s = 'F3'        then
begin n := VK_F3 end
else
if s = 'F4'        then
begin n := VK_F4 end
else
if s = 'F5'        then
begin n := VK_F5 end
else
if s = 'F6'        then
begin n := VK_F6 end
else
if s = 'F7'        then
begin n := VK_F7 end
else
if s = 'F8'        then
begin n := VK_F8 end
else
if s = 'F9'        then
begin n := VK_F9 end
else
if s = 'F10'       then
begin n := VK_F10 end
else
if s = 'F11'       then
begin n := VK_F11 end
else
if s = 'F12'       then
begin n := VK_F12 end
else
if s = 'INS'       then
begin n := VK_INSERT end
else
if s = 'HOME'      then
begin n := VK_HOME end
else
if s = 'DEL'       then
begin n := VK_DELETE end
else
if s = 'DELETE'    then
begin n := VK_DELETE end
else
if s = 'HOME'      then
begin n := VK_HOME end
else
if s = 'END'       then
begin n := VK_END end
else
if s = 'PAGEUP'    then
begin n := VK_PRIOR end
else
if s = 'PAGEDN'    then
begin n := VK_NEXT end
else
if s = 'PRIOR'     then
begin n := VK_PRIOR end
else
if s = 'NEXT'      then
begin n := VK_NEXT end
else
if s = 'SNAPSHOT'  then
begin n := VK_SNAPSHOT end
else
begin
letra := upcase(s[1]);
n := ord (letra);
delete (s, 1, 1);
if letra = '#' then
begin
val (s, n, erro);
if erro <> 0 then
begin exit end;
end
else
if s <> '' then
begin exit end;
end;

keyboardVirtKey (n, comCtl, comShift, comAlt, 100);
end;

processaAciona := true;
end;

{--------------------------------------------------------}
{                  Comando Clica
{--------------------------------------------------------}

function processaClica (lido: string): boolean;
var rect: TRect;
s: string;
x, y, xorig, yorig, erro: integer;
estiloClick: (SIMPLES, DUPLO, NULO);
begin
processaClica := false;

estiloClick := SIMPLES;

lido := trim (lido);
if maiuscAnsi (copy (lido, 1, 5)) = 'DUPLO' then
begin
estiloClick := DUPLO;
delete (lido, 1, 5);
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'NULO' then
begin
estiloClick := NULO;
delete (lido, 1, 4);
end;

lido := trim (lido);
if maiuscAnsi (copy (lido, 1, 4)) = 'TELA' then
begin
xorig := 0;
yorig := 0;
delete (lido, 1, 4);
end
else
begin
getWindowRect (getForegroundWindow, rect);
xorig := rect.left+getSystemMetrics (SM_CXFRAME);
yorig := rect.top+SM_CYCAPTION;
end;

if not extraiValor (lido, s) then
begin exit end;
val (s, x, erro);
if erro <> 0 then
begin exit end;

lido := trim (lido);
if (lido <> '') and (lido[1] = ',') then
begin delete (lido, 1, 1) end;

if not extraiValor (lido, s) then
begin exit end;
val (s, y, erro);
if erro <> 0 then
begin exit end;

case estiloClick of
SIMPLES:
begin mouseClick (x+xorig, y+yorig) end;
DUPLO:
begin mouseDoubleClick (x+xorig, y+yorig) end;
NULO:
begin mouseMove (x+xorig, y+yorig) end;
end;

if lido <> '' then
begin exit end;
processaClica := true;
end;

{--------------------------------------------------------}
{                  Comando Transfere
{--------------------------------------------------------}

function processaTransfere (lido: string): boolean;
var v: char;
p: array [0..255] of char;
trazendo: boolean;
begin
processaTransfere := false;
if lido = '' then
begin exit end;

if maiuscAnsi (copy (lido, 1, 3)) = 'DE ' then
begin
trazendo := false;
delete (lido, 1, 3);
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'PARA ' then
begin
trazendo := true;
delete (lido, 1, 5);
end
else
begin exit end;

if not extraiVariavel (lido, v) then
begin exit end;
lido := trim (lido);
if lido <> '' then
begin exit end;

if trazendo then
begin
getClipBoard (p, 255);
varScript[v] := strPas (p);
end
else
begin
strPCopy (p, varScript[v]);
putClipBoard (p);
end;

processaTransfere := true;
end;

{--------------------------------------------------------}
{                  Comando janela
{--------------------------------------------------------}

function processaJanela (lido: string): boolean;
var
currWnd: hwnd;
txt: array [0..144] of char;
p: integer;
opcao, titulo, s: string;
aoInicio, aoFim, visivel, iconica: boolean;

label prox, achou;

begin
processaJanela := false;
statusUltIO := 0;
if lido = '' then
begin exit end;

opcao := '';
while (lido <> '') and (lido[1] <> ' ') do
begin
opcao := opcao + lido[1];
delete (lido, 1, 1);
end;
opcao := maiuscAnsi (opcao);

lido := trim (lido);
if not extraiValor (lido, s) then
begin exit end;

CurrWnd := GetWindow(crtWindow, GW_HWNDFIRST);

aoInicio := false;
aoFim := false;
if (s <> '') and (s[1] = '*') then
begin
aoInicio := true;
delete (s, 1, 1);
end;

if (s <> '') and (s[length(s)] = '*') then
begin
aoFim := true;
delete (s, length (s), 1);
end;

While CurrWnd <> 0 do
begin
if isWindowEnabled (currWnd) then
begin
visivel := isWindowVisible (currWnd);
iconica := isIconic (currWnd);
GetWindowText(CurrWnd, txt, 144);
titulo := maiuscAnsi (strPas (txt));

if ((visivel or iconica) and (length (titulo) <> 0)) then
begin
p := pos (s, titulo);
if (p = 0)  or
((p <> 1) and aoInicio) or
((p <> (length(titulo) - length(s) + 1)) and aoFim) then
begin goto prox end;

goto achou;
end;
end;
prox:
CurrWnd := GetWindow(CurrWnd, GW_HWNDNEXT);
end;

processaJanela := true;
statusUltIO := 1;
exit;   { no achou }

achou:
if opcao = 'FECHA' then
begin sendMessage (currWnd, WM_CLOSE, 0, 0) end
else
if opcao = 'NORMAL' then
begin
ShowWindow(currWnd, SW_SHOWNORMAL);
setActiveWindow (currWnd);
end
else
if opcao = 'MAXIMIZA' then
begin
ShowWindow(currWnd, SW_MAXIMIZE);
setActiveWindow (currWnd);
end
else
if opcao = 'MINIMIZA' then
begin ShowWindow(currWnd, SW_MINIMIZE) end
else
begin exit end;

processaJanela := true;
end;

{--------------------------------------------------------}
{                  Comando Captura
{--------------------------------------------------------}

function processaCaptura (lido: string): boolean;
var v: char;
p: array [0..255] of char;
opcao: string;
begin
processaCaptura := false;
if lido = '' then
begin exit end;

opcao := '';
while (lido <> '') and (lido[1] <> ' ') do
begin
opcao := opcao + lido[1];
delete (lido, 1, 1);
end;
opcao := maiuscAnsi (opcao);

if not extraiVariavel (lido, v) then
begin exit end;

if (opcao = 'TTULO') or (opcao = 'TITULO') or (opcao = 'ATIVA') then
begin getWindowText (getForegroundWindow, p, 255) end
else
if (opcao = 'FOCO') then
begin
strcopy (p, '');
if getFocus <> 0 then
begin getWindowText (getFocus, p, 255) end;
end
else
if (opcao = 'CAMPO') then
begin
keyboardVirtKey (VK_HOME, false, false, false, 100);
keyboardVirtKey (VK_END, false, true, false, 100);
keyboardVirtKey (VK_INSERT, true, false, false, 100);
getClipBoard (p, 255);
end;

varScript[v] := strPas (p);
processaCaptura := true;
end;

{--------------------------------------------------------}
{                  Comando desvia
{--------------------------------------------------------}

function processaDesvia (lido: string): boolean;
var s: string;
begin
processaDesvia := false;
if fimScript then
begin exit end;   { processamento fora de arquivo }
if lido = '' then
begin exit end;

if maiuscAnsi (copy (lido, 1, 6)) = 'SCRIPT' then
begin
delete (lido, 1, 6);
if (lido = '') or (lido[1] <> ' ') then
begin exit end;
if not extraiValor (lido, s) then
begin exit end;

processaDesvia := carregaScript(s);
linhaAtual := 0;
end;

if (lido <> '') and (lido[1] = '@') then
begin
delete (lido, 1, 1);
s := lido;
if pos (' ', s) <> 0 then
begin exit end;  {rotulo com brancos}
end
else
begin
if not extraiValor (lido, s) then
begin exit end;
if lido <> '' then
begin exit end;
end;

processaDesvia := buscaRotulo (s);
end;

{--------------------------------------------------------}
{        procedimentos comuns de se e enquanto
{--------------------------------------------------------}

function processaTestes (var lido: string; var resultado: boolean): boolean;
var valor1, valor2, mv1, mv2: string;
operador: string[3];
lista: pListaRec;
c: integer;
nega: boolean;

function compensaNumero (s: string): string;
var i: integer;
begin
compensaNumero := s;
for i := 1 to length (s) do
begin if not (s[i] in ['0'..'9']) then
begin exit end end;

s := '00000000000000000000' + s;
s := copy (s, length(s)-20, 255);
compensaNumero := s;
end;

label ok, fim;
begin
processaTestes := false;
resultado := false;
if lido = '' then
begin exit end;

nega := false;
if (maiuscAnsi (copy (lido, 1, 3)) = 'NO') or
(maiuscAnsi (copy (lido, 1, 3)) = 'NAO') then
begin
delete (lido, 1, 3);
lido := trim (lido);
if lido = '' then
begin exit end;
nega := true;
end;

if not extraiValor (lido, valor1) then
begin exit end;
if lido = '' then
begin exit end;

if copy (lido, 1, 2) = '>='  then
begin operador := '>=' end
else
if copy (lido, 1, 2) = '<='  then
begin operador := '<=' end
else
if copy (lido, 1, 2) = '=='  then
begin operador := '==' end
else
if copy (lido, 1, 2) = '<>'  then
begin operador := '<>' end
else
if copy (lido, 1, 3) = '*=*' then
begin operador := '*=*' end
else
if copy (lido, 1, 2) = '=*'  then
begin operador := '=*' end
else
if copy (lido, 1, 2) = '*='  then
begin operador := '*=' end
else
if maiuscAnsi(copy(lido, 1, 2)) = 'EM' then
begin operador := 'EM' end
else
if lido[1] = '=' then
begin operador := '=' end
else
if lido[1] = '<' then
begin operador := '<' end
else
if lido[1] = '>' then
begin operador := '>' end
else
begin exit end;

delete (lido, 1, length (operador));
lido := trim (lido);
if lido = '' then
begin exit end;

if operador <> 'EM' then
begin
if not extraiValor (lido, valor2) then
begin exit end;

mv1 := compensaNumero (maiuscAnsi(valor1));
mv2 := compensaNumero (maiuscAnsi(valor2));
end;

if operador = 'EM' then
begin
if not (extraiNomeLista(lido, valor2)) then
begin exit end;
lista := procuraLista(valor2);
if lista = nil then
begin exit end;
mv1 := compensaNumero (maiuscAnsi(valor1));
for c := 0 to lista^.lista.Count - 1 do
begin
mv2 := compensaNumero(maiuscAnsi(lista^.lista[c]));
if (nega xor (mv1 = mv2)) then
begin goto ok end;
end;
end;


if (operador = '=')   and (nega xor (mv1 = mv2)) then
begin goto ok end;
if (operador = '<')   and (nega xor (mv1 < mv2)) then
begin goto ok end;
if (operador = '>')   and (nega xor (mv1 > mv2)) then
begin goto ok end;

if (operador = '<=')  and (nega xor (mv1 <= mv2))         then
begin goto ok end;
if (operador = '>=')  and (nega xor (mv1 >= mv2))         then
begin goto ok end;
if (operador = '<>')  and (nega xor (mv1 <> mv2))         then
begin goto ok end;

if (operador = '==')  and (nega xor (valor1 = valor2))    then
begin goto ok end;
if (operador = '*=*') and (nega xor (pos (valor2, valor1) <> 0)) then
begin goto ok end;
if (operador = '=*')  and (nega xor (pos (valor2, valor1) = 1))  then
begin goto ok end;
if (operador = '*=')  and
(nega xor (pos (valor2, valor1) = length(valor1)-length(valor2)+1)) then
begin goto ok end;

goto fim;   { com resultado falso }

ok:
resultado := true;
fim:
processaTestes := true;
lido := trim (lido);
end;

{--------------------------------------------------------}
{                  Comando se
{--------------------------------------------------------}

function processaSe (lido: string): boolean;
var verdadeiro: boolean;

procedure buscaSenaoOuFimSe;
var i, nivel: integer;
lido: string;
x: boolean;
begin
nivel := 1;
for i := linhaAtual+1 to nlinhasScript do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
while pos ('  ', lido) <> 0 do
begin delete (lido, pos ('  ', lido), 1) end;
if copy (lido, 1, 3) = 'SE ' then
begin
delete (lido, 1, 3);
if processaTestes (lido, x) then
begin if trim (lido) = '' then
begin nivel := nivel + 1 end end;
end
else
if lido = 'FIM SE' then
begin
nivel := nivel - 1;
if nivel = 0 then
begin linhaAtual := i end;
exit;
end
else
if (lido = 'SENAO') or (lido = 'SENO') then
begin
if nivel = 1 then
begin linhaAtual := i end;
exit;
end;
end;

linhaAtual := nlinhasScript + 1;
end;

begin
processaSe := false;
if not processaTestes (lido, verdadeiro) then
begin exit end;

processaSe := true;

if verdadeiro then
begin
if lido <> '' then
begin processaSe := cmdScript (lido) end;
end
else
begin
if lido =  '' then
begin buscaSenaoOuFimSe end;
end;
end;

{--------------------------------------------------------}
{                busca um comando fim
{--------------------------------------------------------}

procedure buscaFim (deQue: string);
var i: integer;
lido: string;
begin
for i := linhaAtual+1 to nlinhasScript do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
while pos ('  ', lido) <> 0 do
begin delete (lido, pos ('  ', lido), 1) end;
if lido = 'FIM ' + deQue then
begin
linhaAtual := i;
exit;
end;
end;

linhaAtual := nLinhasScript + 1;
end;

{--------------------------------------------------------}
{                  Comando enquanto
{--------------------------------------------------------}

function processaEnquanto (lido: string): boolean;
var verdadeiro: boolean;

begin
processaEnquanto := false;
if not processaTestes (lido, verdadeiro) then
begin exit end;

if not verdadeiro then
begin buscaFim ('ENQUANTO') end;

processaEnquanto := true;
end;

{--------------------------------------------------------}
{                  Comando seno
{--------------------------------------------------------}

function processaSenao (lido: string): boolean;
begin
processaSenao := false;
if lido <> '' then
begin exit end;

buscaFim ('SE');

processaSenao := true;
end;

{--------------------------------------------------------}
{                  Comando repete
{--------------------------------------------------------}

function processaRepete (lido: string; continuando: boolean): boolean;
var natual, nmax: longint;
valor: string;
v: char;
erro: integer;

begin
processaRepete := false;

if not extraiVariavel (lido, v) then
begin exit end;
if lido = '' then
begin exit end;

if continuando then
begin
val (varScript[v], natual, erro);
if erro <> 0 then
begin exit end;
end
else
begin natual := 0 end;

if not extraiValor (lido, valor) then
begin exit end;
val (valor, nmax, erro);
if erro <> 0 then
begin exit end;

natual := natual + 1;
str (natual, varScript[v]);

if natual > nmax then
begin buscaFim ('REPETE') end;

processaRepete := true;
end;

{--------------------------------------------------------}
{                  Comandos de fim de bloco
{--------------------------------------------------------}

function processaFimBloco (lido: string): boolean;
var i, p: integer;
cmd: string;
begin
processaFimBloco := false;
if lido = '' then
begin exit end;

lido := maiuscAnsi (lido);
if lido = 'SE' then
begin
processaFimBloco := true;
exit;
end;

if lido = 'ENQUANTO' then
begin
for i := linhaAtual-1 downto 1 do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
lido := copy (lido, 1, pos (' ', lido)-1);
if lido = 'ENQUANTO' then
begin
linhaAtual := i - 1;
processaFimBloco := true;
exit;
end;
end;

exit;  { retorna erro se no achou Enquanto }
end;

if lido = 'REPETE' then
begin
for i := linhaAtual-1 downto 1 do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
p := pos (' ', lido);
cmd := copy (lido, 1, p-1);
delete (lido, 1, p);
lido := trim (lido);
if cmd = 'REPETE' then
begin
linhaAtual := i;
processaFimBloco := processaRepete (lido, true);
exit;
end;
end;

exit;  { retorna erro se no achou Repete }
end;

processaFimBloco := true;
end;

{--------------------------------------------------------}
{                  Comando executa
{--------------------------------------------------------}

function processaExecuta (lido: string): boolean;
var comando, param, nomeDir: string;
espera: boolean;
i: integer;
begin
processaExecuta := false;

espera := true;
if (lido <> '') and (lido [length(lido)] = '&') then
begin
espera := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, comando) then
begin exit end;
if lido <> '' then
begin exit end;

if (comando <> '') and (comando[1] = '"') then
begin
delete (comando, 1, 1);
i := pos ('"', comando);
if i = 0 then
begin param := '' end
else
begin
param := copy (comando, i+1, 999);
param := trim(param);
comando := copy (comando, 1, i-1);
end;
end
else
begin
i := pos (' ', comando);
if i = 0 then
begin param := '' end
else
begin
param := copy (comando, i+1, 999);
delete (comando, i, 999);
end;
end;

getdir (0, nomeDir);
while sintFalando do
begin end;
if executaProg (comando, nomeDir, param) >= 32 then
begin
if espera then
begin esperaProgVoltar end;
end
else
begin exit end;

processaExecuta := true;
end;

{--------------------------------------------------------}
{                  Comando Termina
{--------------------------------------------------------}

function processaTermina (lido: string): boolean;
begin
fimScript := true;
fimScriptMudo := false;
if maiuscAnsi(lido) = 'MUDO' then
begin fimScriptMudo := true end;
processaTermina := true;
end;

{--------------------------------------------------------}
{                  Comando chama
{--------------------------------------------------------}

function processaChama (lido: string): boolean;
var s: string;
begin
processaChama := false;
if fimScript then
begin exit end;   { processamento fora de arquivo }
if lido = '' then
begin exit end;

if lido[1] = '@' then
begin
delete (lido, 1, 1);
s := lido;
if pos (' ', s) <> 0 then
begin exit end;  {rotulo com brancos}
end
else
begin
if not extraiValor (lido, s) then
begin exit end;
if lido <> '' then
begin exit end;
end;

if topoRetorno < MAXRETORNO then
begin
topoRetorno := topoRetorno + 1;
pilhaRetorno[topoRetorno] := linhaAtual;
end
else
begin
sintWriteln (STACK_OVERFLOW);  {'Muitas chamadas sem retorno'}
exit;
end;

processaChama := buscaRotulo (s);
end;

{--------------------------------------------------------}
{                  Comando Busca
{--------------------------------------------------------}

function processaBusca (lido: string): boolean;
var v: char;
valor: string;
emDiretorio: boolean;
pvalor: array [0..144] of char;
begin
processaBusca := false;

if not extraiVariavel (lido, v) then
begin exit end;
if lido = '' then
begin exit end;

emDiretorio := false;
if maiuscAnsi (copy (lido, 1, 3)) = 'DIR' then
begin
emDiretorio := true;
delete (lido, 1, 4);
lido := trim (lido);
end;

if (maiuscAnsi (copy (lido, 1, 7)) = 'PRXIMO') or
(maiuscAnsi (copy (lido, 1, 7)) = 'PROXIMO') then
begin
delete (lido, 1, 7);
if lido <> '' then
begin exit end;

repeat
if FindNext(DirInfo) = 0 then
begin
if dirInfo.attr and atribBusca <> 0 then
begin varScript [v] := DirInfo.FindData.cFileName end
end
else
begin
varScript [v] := '';
break;
end;
until dirInfo.attr and atribBusca <> 0;
end
else
if lido = '' then
begin getDir (0, varScript [v]) end
else
begin
if not extraiValor (lido, valor) then
begin exit end;
if lido <> '' then
begin exit end;

if emDiretorio then
begin atribBusca := FaDirectory end
else
begin atribBusca := FaArchive end;

strPCopy (pvalor, valor);
if FindFirst(pvalor, atribBusca, DirInfo) = 0 then
begin varScript [v] := DirInfo.FindData.cFileName end
else
begin varScript [v] := '' end;
end;

varScript[v] := trim (varScript [v]);
processaBusca := true;
end;

{--------------------------------------------------------}
{                  Comando Renomeia
{--------------------------------------------------------}

function processaRenomeia (lido: string): boolean;
var nomeArq1, nomeArq2: string;
ignoraErro: boolean;
begin
processaRenomeia := false;
if lido = '' then
begin exit end;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq1) then
begin exit end;
if not extraiValor (lido, nomeArq2) then
begin exit end;
if lido <> '' then
begin exit end;

assign (arq, nomeArq1);
{$I-} rename (arq, nomeArq2);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then
begin exit end;

processaRenomeia := true;
end;

{--------------------------------------------------------}
{                  Comando Replica
{--------------------------------------------------------}

function processaReplica (lido: string): boolean;
type
pvet30k = ^vet30k;
vet30k = array [0..29999] of byte;

var nomeArq1, nomeArq2: string;
ignoraErro: boolean;
arq1, arq2: file;
buf: pvet30k;
lidos, escritos: integer;
label fim;

begin
processaReplica := false;
if lido = '' then
begin exit end;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
end;

if not extraiValor (lido, nomeArq1) then
begin exit end;
if not extraiValor (lido, nomeArq2) then
begin exit end;
if lido <> '' then
begin exit end;

new (buf);

assign (arq1, nomeArq1);
assign (arq2, nomeArq2);
{$I-} reset (arq1, 1);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then
begin goto fim end;
{$I-} rewrite (arq2, 1);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then
begin goto fim end;

while not eof (arq1) do
begin
{$I-} blockRead (arq1, buf^, sizeof(buf^), lidos);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then
begin
sintWriteln (ERRO_ARQUIVO + ' ' + nomearq1);
goto fim;
end;

{$I-} blockWrite (arq2, buf^, lidos, escritos);  {$I+}
if (escritos <> lidos) and (not ignoraErro) then
begin
sintWriteln (ERRO_ESCRITA + ' ' + nomearq2);
goto fim;
end;
end;

processaReplica := true;

fim:
dispose (buf);
{$I-}  close (arq1);  {$I+}
if ioresult <> 0 then
begin end;
{$I-}  close (arq2);  {$I+}
if ioresult <> 0 then
begin end;
end;

{--------------------------------------------------------}
{                  Comando Dir
{--------------------------------------------------------}

function processaDir (lido: string): boolean;
var op: char;
nomeDir: string;
ignoraErro: boolean;
begin
processaDir := false;
ignoraErro := false;

if (lido <> '') and (lido [length(lido)] = '&') then
begin
ignoraErro := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if maiuscAnsi (copy (lido, 1, 5)) = 'CRIA ' then
begin op := 'C' end
else
if maiuscAnsi (copy (lido, 1, 7)) = 'REMOVE ' then
begin op := 'R' end
else
if maiuscAnsi (copy (lido, 1, 6)) = 'TROCA ' then
begin op := 'T' end
else
begin exit end;

while (lido <> '') and (lido [1] <> ' ') do
begin delete (lido, 1, 1) end;
lido := trim (lido);
if not extraiValor (lido, nomeDir) then
begin exit end;
if lido <> '' then
begin exit end;

{$I-}
case op of
'C':
begin mkdir (nomeDir) end;
'R':
begin rmdir (nomeDir) end;
'T':
begin chdir (nomeDir) end;
end;
{$I+}

if (ioresult <> 0) and (not ignoraErro) then
begin
sintWriteln (ERRO_DIR + nomeDir);
exit;
end;

processaDir := true;
end;

{--------------------------------------------------------}
{                  Comando Retorna
{--------------------------------------------------------}

function processaRetorna (lido: string): boolean;
begin
processaRetorna := false;
if lido <> '' then
begin exit end;

if topoRetorno = 0 then
begin
sintWriteln (STACK_UNDERFLOW);  {'Retorno sem chamada'}
exit;
end;

linhaAtual := pilhaRetorno[topoRetorno];
topoRetorno := topoRetorno -1;

processaRetorna := true;
end;

{--------------------------------------------------------}
{                    Comando IP
{--------------------------------------------------------}

function processaIP (lido: string): boolean;
var
endip: sockaddr_in;
local: boolean;
arqSel, v: char;
tam: integer;
begin
processaIP := false;
if lido = '' then
begin exit end;

if maiuscAnsi (copy (lido, 1, 6)) = 'LOCAL ' then
begin
local := true;
delete (lido, 1, 6);
end
else
if maiuscAnsi (copy (lido, 1, 7)) = 'REMOTO ' then
begin
local := false;
delete (lido, 1, 7);
end
else
begin exit end;

lido := trim (lido);

if not extraiNumArq (lido, arqSel) then
begin exit end;
if not extraiVariavel (lido, v) then
begin exit end;

with arquivo [arqSel] do
begin
if soquete < 0 then
begin exit end;

tam := sizeof (sockaddr_in);
if local then
begin getSockName (soquete, endip, tam) end
else
begin getpeername(soquete, endip, tam) end;

varScript[v] := strPas (inet_ntoa (TInAddr(endip.sin_addr.S_addr)));
end;

processaIP := true;
end;

{--------------------------------------------------------}
{                    Comando MSAA
{--------------------------------------------------------}

function processaMSAA (lido: string): boolean;
var x, y, dx, dy, erro: integer;
valor: string;
v: char;
begin
processaMSAA := false;
if (maiuscAnsi (copy (lido, 1, 8))) = 'MONITORA' then
begin
delete (lido, 1, 8);
MSAAMonitora (true);
end
else
if (maiuscAnsi (copy (lido, 1, 3))) = 'FIM' then
begin
delete (lido, 1, 3);
MSAAMonitora (false);
end
else
if (maiuscAnsi (copy (lido, 1, 5))) = 'CHECA' then
begin
delete (lido, 1, 5);
if not extraiVariavel (lido, v) then
begin exit end;
if MSAAPegaEvento then
begin varScript[v] := '1' end
else
begin varScript[v] := '0' end;
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'CAPTURA' then
begin
delete (lido, 1, 7);
if not extraiValor (lido, valor) then
begin exit end;
val (valor, x, erro);
if erro <> 0 then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, y, erro);
if erro <> 0 then
begin exit end;
MSAAPegaPonto (x, y);
end
else
if (maiuscAnsi (copy (lido, 1, 4))) = 'AREA' then
begin
delete (lido, 1, 4);
MSAACoord (x, y, dx, dy);
if not extraiVariavel (lido, v) then
begin exit end;
str (x, varScript[v]);
if not extraiVariavel (lido, v) then
begin exit end;
str (y, varScript[v]);
if not extraiVariavel (lido, v) then
begin exit end;
str (dx, varScript[v]);
if not extraiVariavel (lido, v) then
begin exit end;
str (dy, varScript[v]);
end
else
if (maiuscAnsi (copy (lido, 1, 4))) = 'NOME' then
begin
delete (lido, 1, 4);
if not extraiVariavel (lido, v) then
begin exit end;
varScript[v] := MSAANome;
end
else
if ((maiuscAnsi (copy (lido, 1, 6))) = 'CODIGO') or
((maiuscAnsi (copy (lido, 1, 6))) = 'CDIGO') then
begin
delete (lido, 1, 6);
if not extraiVariavel (lido, v) then
begin exit end;
str (MSAACodTipo, varScript[v]);
end
else
if ((maiuscAnsi (copy (lido, 1, 4))) = 'TIPO') then
begin
delete (lido, 1, 4);
if not extraiVariavel (lido, v) then
begin exit end;
varScript[v] := MSAATipo;
end
else
if ((maiuscAnsi (copy (lido, 1, 6))) = 'ESTADO') then
begin
delete (lido, 1, 6);
if not extraiVariavel (lido, v) then
begin exit end;
varScript[v] := MSAAStatus;
end
else
if ((maiuscAnsi (copy (lido, 1, 5))) = 'VALOR') then
begin
delete (lido, 1, 5);
if not extraiVariavel (lido, v) then
begin exit end;
varScript[v] := MSAAValor;
end
else
begin exit end;

processaMSAA := true;
end;

{--------------------------------------------------------}
{                    Comando MENU
{--------------------------------------------------------}

function processaMenu (lido: string): boolean;
var xmin, ymin, xmax, ymax, erro: integer;
valor, s: string;
v1, v2, v3: char;
c1, c2: char;
n: integer;
selec: boolean;
begin
processaMenu := false;
if (maiuscAnsi (copy (lido, 1, 4))) = 'CRIA' then
begin
delete (lido, 1, 4);
if not extraiValor (lido, valor) then
begin exit end;
val (valor, xmin, erro);
if erro <> 0 then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, ymin, erro);
if erro <> 0 then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, xmax, erro);
if erro <> 0 then
begin exit end;
if not extraiValor (lido, valor) then
begin exit end;
val (valor, ymax, erro);
if erro <> 0 then
begin exit end;
folheiaCria (xmin, ymin, xmax, ymax);
itemInic := 1;
end
else
if (maiuscAnsi (copy (lido, 1, 8))) = 'ADICIONA' then
begin
delete (lido, 1, 8);
if not extraiValor (lido, valor) then
begin exit end;
folheiaAdiciona(valor);
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'TERMINA' then
begin
delete (lido, 1, 7);
folheiaLimpa;
folheiaDestroi;
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'EXECUTA' then
begin
delete (lido, 1, 7);
if not extraiVariavel (lido, v1) then
begin exit end;  // nmero do item
if not extraiVariavel (lido, v2) then
begin exit end;  // letra acionada
if not extraiVariavel (lido, v3) then
begin exit end;  // item escolhido
repeat
try
itemInic := strToInt (trim(varScript[v1]));
except end;
if itemInic <= 0 then
begin itemInic := 1 end;
folheiaExecuta(itemInic, n, c1, c2, true);
until (c1 <> #0) or (c2 in [F1..F12]);

str (n, varScript[v1]);

if c1 >= ' ' then
begin varScript[v2] := c1 end
else
if (c1 = #0) and (c2 in [F1..F12]) then
begin varScript[v2] := '#0#' + intToStr (ord(c2) - ord(F1) + 59) end
else
begin
str (ord(c1), s);
varScript[v2] := '#' + s;
end;
folheiaObtemItem(n, varScript[v3], selec);
end
else
begin exit end;

if lido <> '' then
begin exit end;
processaMenu := true;
end;

{--------------------------------------------------------}
{                    Comando IMAGEM
{--------------------------------------------------------}

function processaImagem (lido: string): boolean;
var
nomeArq: string;
x, y, erro: integer;
ignoraErro: boolean;
s: string;
begin
processaImagem := false;
if lido = '' then
begin
closeBMP;
processaImagem := true;
exit;
end;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then
begin exit end;
if lido <> '' then
begin
if not extraiValor (lido, s) then
begin exit end;
val (s, x, erro);
if erro <> 0 then
begin exit end;
if not extraiValor (lido, s) then
begin exit end;
val (s, y, erro);
if erro <> 0 then
begin exit end;

if lido <> '' then
begin exit end;
end
else
begin
x := 0;
y := 0;
end;

closeBMP;
if trim (nomeArq) <> '' then
begin
if (ansiUpperCase (copy (nomeArq, length (nomeArq)-3, 4)) = '.JPG') or
(ansiUpperCase (copy (nomeArq, length (nomeArq)-5, 5)) = '.JPEG') then
begin
if FileExists(nomeArq) then
begin
CopyJpegToBmp (nomeArq, 'c:\$$$.bmp');
nomeArq := 'c:\$$$.bmp';
end;
end;
if not openBMP (nomeArq) then
begin
if not ignoraErro then
begin exit end;
end
else
begin paintBMP (x, y) end;
end;

processaImagem := true;
if nomeArq = 'c:\$$$.bmp' then
begin DeleteFile('c:\$$$.bmp') end;
end;

{--------------------------------------------------------}
{                    Comando SENSOR
{--------------------------------------------------------}

type
TInp32 = function (PortAddress: word): byte;   stdcall;
TOut32 = procedure (PortAddress: word; data: byte);   stdcall;

const
basepr = $378;    // 378 ou 278

var
Inp32: TInp32;
Out32: TOut32;
HInpOut32: THandle;
mascChaves: byte;
vetChaves: array[1..32] of boolean;

procedure inicChaves;
begin
if hInpOut32 <> 0 then
begin exit end;

hInpOut32 := LoadLibrary ('inpout32.dll');
if hInpOut32 = 0 then
begin
beep;
sintWriteln ('inpout32.dll no disponvel.');
exit;
end;

inp32 := GetProcAddress(HInpOut32, 'Inp32');
out32 := GetProcAddress(HInpOut32, 'Out32');

out32 ($37A, $ff);
sleep (1);
out32 ($378, 1);
sleep (1);
mascChaves := inp32 ($379);
end;

procedure obtemChaves;
var x, i: integer;
begin
if hInpOut32 = 0 then
begin exit end;

for i := 0 to 7 do
begin
out32 ($37A, $ff);
sleep (1);
out32 ($378, not ($80 shr i));
sleep (1);
x := inp32 ($379) xor mascChaves;

vetChaves[i*4+1] := (x and $80) <> 0;
vetChaves[i*4+2] := (x and $40) <> 0;
vetChaves[i*4+3] := (x and $20) <> 0;
vetChaves[i*4+4] := (x and $10) <> 0;
end;
end;


function processaSensor (lido: string): boolean;
var
v: char;
n: integer;
begin
processaSensor := false;
if not sensorAtivo then
begin inicChaves end;

if not extraiVariavel (lido, v) then
begin exit end;
obtemChaves;

varScript [v] := '0';
for n := 1 to 32 do
begin if vetChaves[n]  then
begin
varScript [v] := intToStr (n);
exit;
end end;
end;

{--------------------------------------------------------}
{             executa um comando do script
{--------------------------------------------------------}

function executaComando (cmd, lido: string): boolean;
begin
if cmd = '' then
begin
executaComando := false;
exit;
end;

lido := trim (lido);
if debug then
begin sintWriteln (cmd + ' ' + lido) end;

cmd := maiuscAnsi (cmd);
if cmd='MIDI' then
begin executaComando:=processaMIDI(lido) end
else

if cmd = 'DEBUG'     then
begin executaComando := processaDebug (lido) end
else
if cmd = 'SEJA'      then
begin executaComando := processaSeja (lido) end
else
if cmd = 'TELA'      then
begin executaComando := processaTela (lido) end
else
if cmd = 'COR'       then
begin executaComando := processaCor (lido) end
else
if cmd = 'FUNDO'     then
begin executaComando := processaFundo (lido) end
else
if cmd = 'ABRE'      then
begin executaComando := processaAbre (lido) end
else
if cmd = 'FECHA'     then
begin executaComando := processaFecha (lido) end
else
if cmd = 'INTERNET'  then
begin executaComando := processaInternet (lido) end
else
if cmd = 'CONECTA'   then
begin executaComando := processaConecta (lido) end
else
if cmd = 'SERVE'     then
begin executaComando := processaServe (lido) end
else
if cmd = 'OBSERVA'   then
begin executaComando := processaObserva (lido) end
else
if cmd = 'ESCREVE'   then
begin executaComando := processaEscreve (lido) end
else
if cmd = 'BIPA'      then
begin executaComando := processaBipa (lido) end
else
if cmd = 'SOMA'      then
begin executaComando := processaSoma (lido) end
else
if cmd = 'SUBTRAI'   then
begin executaComando := processaContas (lido, '-') end
else
if cmd = 'MULTIPLICA' then
begin executaComando := processaContas (lido, '*') end
else
if cmd = 'DIVIDE'    then
begin executaComando := processaContas (lido, '/') end
else
if cmd = 'CONCATENA' then
begin executaComando := processaConcatena (lido) end
else
if cmd = 'COPIA'     then
begin executaComando := processaCopia (lido) end
else
if cmd = 'SOLETRA'     then
begin executaComando := processaSoletra (lido) end
else
if cmd = 'LISTA'     then
begin executaComando := processaLista (lido) end
else
if cmd = 'FALAHORA'     then
begin executaComando := processaFalaHora (lido) end
else
if (cmd = 'TITULO') or (cmd = 'TTULO')    then
begin executaComando := processaTitulo (lido) end
else
if cmd = 'DELETA'     then
begin executaComando := processaDeleta (lido) end
else
if cmd = 'SUBSTITUI' then
begin executaComando := processaSubstitui (lido) end
else
if cmd = 'TOCA'      then
begin executaComando := processaToca (lido) end
else
if cmd = 'FALA'      then
begin executaComando := processaFala (lido) end
else
if cmd = 'MCI'       then
begin executaComando := processaMci (lido) end
else
if (cmd = 'L') or
(cmd = 'LE')      then
begin executaComando := processaLe (lido) end
else
if cmd = 'CHECA'     then
begin executaComando := processaCheca (lido) end
else
if cmd = 'REMOVE'    then
begin executaComando := processaRemove (lido) end
else
if cmd = 'RENOMEIA'  then
begin executaComando := processaRenomeia (lido) end
else
if cmd = 'REPLICA'   then
begin executaComando := processaReplica (lido) end
else
if cmd = 'CMD'       then
begin executaComando := processaCmd (lido) end
else
if cmd = 'ESPERA'    then
begin executaComando := processaEspera (lido) end
else
if cmd = 'DIGITA'    then
begin executaComando := processaDigita (lido) end
else
if cmd = 'ACIONA'    then
begin executaComando := processaAciona (lido) end
else
if cmd = 'CLICA'     then
begin executaComando := processaClica (lido) end
else
if cmd = 'CAPTURA'   then
begin executaComando := processaCaptura (lido) end
else
if cmd = 'TRANSFERE' then
begin executaComando := processaTransfere (lido) end
else
if cmd = 'JANELA'    then
begin executaComando := processaJanela (lido) end
else
if cmd = 'DESVIA'    then
begin executaComando := processaDesvia (lido) end
else
if cmd = 'SE'        then
begin executaComando := processaSe (lido) end
else
if (cmd = 'SENAO') or (cmd = 'SENO')
then
begin executaComando := processaSenao (lido) end
else
if cmd = 'ENQUANTO'  then
begin executaComando := processaEnquanto (lido) end
else
if cmd = 'REPETE'    then
begin executaComando := processaRepete (lido, false) end
else
if cmd = 'FIM'       then
begin executaComando := processaFimBloco (lido) end
else
if cmd = 'EXECUTA'   then
begin executaComando := processaExecuta (lido) end
else
if cmd = 'DIR'       then
begin executaComando := processaDir (lido) end
else
if cmd = 'BUSCA'     then
begin executaComando := processaBusca (lido) end
else
if cmd = 'TERMINA'   then
begin executaComando := processaTermina (lido) end
else
if cmd = 'CHAMA'     then
begin executaComando := processaChama (lido) end
else
if cmd = 'RETORNA'   then
begin executaComando := processaRetorna (lido) end
else
if cmd = 'RANDOMIZA' then
begin executaComando := processaRandomiza (lido) end
else
if cmd = 'IP'        then
begin executaComando := processaIp (lido) end
else
if cmd = 'MSAA'      then
begin executaComando := processaMSAA (lido) end
else
if cmd = 'MENU'      then
begin executaComando := processaMENU (lido) end
else
if cmd = 'IMAGEM'    then
begin executaComando := processaImagem (lido) end
else
if cmd = 'SENSOR'      then
begin executaComando := processaSensor (lido) end

else
begin
executaComando := false;
sintWriteln (COMANDO_INVALIDO + cmd);   {'Comando invlido: '}
end;
end;

{--------------------------------------------------------}
{                executa uma linha
{--------------------------------------------------------}

function execCmdScript (lido: string; procExterno: boolean): boolean;
var c: char;
begin
execCmdScript := true;
lido := trim (lido);
if (lido = '') or (lido[1] = '*') or (lido[1] = '@') then
begin exit end;

cmd := '';
repeat
c := upcase (lido [1]);
delete (lido, 1, 1);
if c <> ' ' then
begin cmd := cmd + upcase (c) end;
until (c = ' ') or (lido = '');

if procExterno and
((cmd = 'REPETE') or (cmd = 'ENQUANTO') or
(cmd = 'SENAO') or (cmd = 'SENO') or
(cmd = 'FIM')) then
begin execCmdScript := false end    {esses no so vlidos como imediatos}
else
begin
erroProc := not executaComando (cmd, lido);
execCmdScript := not erroProc;
end;
end;

{--------------------------------------------------------}
{      executa uma linha em processamento externo
{--------------------------------------------------------}

function cmdScript (lido: string): boolean;
begin
cmdScript := execCmdScript (lido, true);
end;

{--------------------------------------------------------}
{                executa todo script
{--------------------------------------------------------}

function executaScript (nomeArq, rotulo: string; var ultLinhaProc: integer): integer;
var
lido: string;

begin
if not carregaScript (nomeArq) then
begin
executaScript := SCR_SEMARQUIVO;
exit;
end;

linhaAtual := 1;
erroProc := false;
fimScript := false;
cmd := '';
topoRetorno := 0;
statusUltIO := 0;

if (rotulo <> '') and (not buscaRotulo (rotulo)) then
begin executaScript := SCR_ROTULOINVALIDO end
else
begin
while (linhaAtual <= nLinhasScript) and (not fimScript) and
(not erroProc) do
begin
lido := script[linhaAtual];
execCmdScript (lido, false);
if (not fimScript) and (not erroProc) then
begin linhaAtual := linhaAtual + 1 end;
end;

if erroProc then
begin executaScript := SCR_ERROEXEC end
else
begin executaScript := SCR_OK end;
end;

liberaScript;
ultLinhaProc := linhaAtual;
end;

{--------------------------------------------------------}
{              zera as variveis do script
{      Ateno: carregar e executar script no zeram,
{        isso s ocorre na inicializao do mdulo
{--------------------------------------------------------}

procedure zeraVarScript;
var c: char;
i: integer;
ano0, mes0, dia0: word;
hora0, minuto0, segundo0, cent0: word;
{$IFDEF VER150}
date_and_time: TDateTime;
{$ENDIF}

begin
linhaAtual := 1;
erroProc := false;
fimScript := false;
cmd := '';
topoRetorno := 0;
statusUltIO := 0;

nomeVarLonga.Clear;

for c := '0' to '9' do
begin arquivo[c].aberto := false end;

for c := 'A' to chr(ord('Z') + 101) do
begin varScript[c] := '' end;

for i :=0 to 19 do
begin
if varLista[i] <> nil then
begin
zeraLista(varLista[i]);
varLista[i] := nil;
end;
end;
fimScript := true;
delay (1);   { estabilizador de processamento virtual }

{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano0, mes0, dia0);
decodeTime (date_and_time, hora0, minuto0, segundo0, cent0);
semana0 := dayOfTheWeek (date_and_time);
{$ELSE}
getDate(ano0, mes0, dia0, semana0);
gettime (hora0, minuto0, segundo0, cent0);
{$ENDIF}
tempo0 := ((hora0*60+minuto0)*60+segundo0)*100+cent0;
end;

{--------------------------------------------------------}
{                obtm uma varivel longa
{--------------------------------------------------------}

function obtemVarLongaScript (nome: string): string;
var n: integer;
begin
n := nomeVarLonga.indexOf(nome);
result := varScript[chr (n+1 + ord('Z'))];
end;

{--------------------------------------------------------}
{                altera uma varivel longa
{--------------------------------------------------------}

procedure alteraVarLongaScript (nome, valor: string);
var n: integer;
begin
n := nomeVarLonga.indexOf(nome);
if n < 0 then
begin
nomeVarLonga.Add(nome);
n := nomeVarLonga.count-1;
end;
varScript[chr (n+1 + ord('Z'))] := valor;
end;

function getflags():string;
var
flags:string;
begin
flags:='';
if (GetKeyState(16)<0) then
begin flags:=flags+'1' end
else
begin flags:=flags+'0' end;
if (GetKeyState(17)<0) then
begin flags:=flags+'1' end
else
begin flags:=flags+'0' end;
if (GetKeyState(18)<0) then
begin flags:=flags+'1' end
else
begin flags:=flags+'0' end;
getflags:=flags;
end; {function getflags}

begin
nomeVarLonga := TStringList.Create;
zeraVarScript;
MIDIAberto := false;
end.
